/* number-picker.c generated by valac 0.56.17, the Vala compiler
 * generated from number-picker.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _NumberPickerPrivate NumberPickerPrivate;
enum  {
	NUMBER_PICKER_0_PROPERTY,
	NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY,
	NUMBER_PICKER_NUM_PROPERTIES
};
static GParamSpec* number_picker_properties[NUMBER_PICKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NUMBER_PICKER_VALUE_PICKED_SIGNAL,
	NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL,
	NUMBER_PICKER_NUM_SIGNALS
};
static guint number_picker_signals[NUMBER_PICKER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NumberPicker {
	GtkGrid parent_instance;
	NumberPickerPrivate * priv;
};

struct _NumberPickerClass {
	GtkGridClass parent_class;
};

struct _NumberPickerPrivate {
	SudokuBoard* board;
	GtkButton* clear_button;
	GtkButton** value_buttons;
	gint value_buttons_length1;
	gint _value_buttons_size_;
	GtkToggleButton** earmark_buttons;
	gint earmark_buttons_length1;
	gint _earmark_buttons_size_;
	gboolean _is_earmark_picker;
};

static gint NumberPicker_private_offset;
static gpointer number_picker_parent_class = NULL;

VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN NumberPicker* number_picker_new (SudokuGame* game,
                                 gboolean for_earmarks);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuGame* game,
                                       gboolean for_earmarks);
static void number_picker_set_is_earmark_picker (NumberPicker* self,
                                          gboolean value);
VALA_EXTERN gboolean number_picker_get_is_earmark_picker (NumberPicker* self);
static void _________lambda4_ (NumberPicker* self,
                        GtkButton* this_button);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
static void __________lambda4__gtk_button_clicked (GtkButton* _sender,
                                            gpointer self);
static void _________lambda5_ (NumberPicker* self,
                        GtkToggleButton* this_button);
static void __________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                   gpointer self);
static void _________lambda6_ (NumberPicker* self,
                        GtkWidget* this_button);
static void __________lambda6__gtk_widget_realize (GtkWidget* _sender,
                                            gpointer self);
static void __lambda7_ (NumberPicker* self,
                 GtkButton* this_button);
VALA_EXTERN void number_picker_set_earmark_buttons_sensitive (NumberPicker* self,
                                                  gboolean enabled);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
VALA_EXTERN void number_picker_set_earmark_buttons (NumberPicker* self,
                                        gint row,
                                        gint col);
VALA_EXTERN void number_picker_set_earmark_button (NumberPicker* self,
                                       gint num,
                                       gboolean state);
static void number_picker_real_dispose (GObject* base);
static void g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void number_picker_finalize (GObject * obj);
static GType number_picker_get_type_once (void);
static void _vala_number_picker_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_number_picker_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
number_picker_get_instance_private (NumberPicker* self)
{
	return G_STRUCT_MEMBER_P (self, NumberPicker_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/number-picker.vala"
	return self ? g_object_ref (self) : NULL;
#line 178 "number-picker.c"
}

static void
_________lambda4_ (NumberPicker* self,
                   GtkButton* this_button)
{
	gint val = 0;
	gconstpointer _tmp0_;
#line 71 "../src/number-picker.vala"
	g_return_if_fail (this_button != NULL);
#line 72 "../src/number-picker.vala"
	_tmp0_ = g_object_get_data ((GObject*) this_button, "number-contained");
#line 72 "../src/number-picker.vala"
	val = (gint) ((gintptr) _tmp0_);
#line 73 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_VALUE_PICKED_SIGNAL], 0, val);
#line 74 "../src/number-picker.vala"
	if (val == 0) {
#line 75 "../src/number-picker.vala"
		number_picker_set_clear_button_visibility (self, FALSE);
#line 199 "number-picker.c"
	}
}

static void
__________lambda4__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self)
{
#line 71 "../src/number-picker.vala"
	_________lambda4_ ((NumberPicker*) self, _sender);
#line 209 "number-picker.c"
}

static void
_________lambda5_ (NumberPicker* self,
                   GtkToggleButton* this_button)
{
	gint number_contained = 0;
	gconstpointer _tmp0_;
	gboolean toggle_active = FALSE;
#line 81 "../src/number-picker.vala"
	g_return_if_fail (this_button != NULL);
#line 82 "../src/number-picker.vala"
	_tmp0_ = g_object_get_data ((GObject*) this_button, "number-contained");
#line 82 "../src/number-picker.vala"
	number_contained = (gint) ((gintptr) _tmp0_);
#line 83 "../src/number-picker.vala"
	toggle_active = gtk_toggle_button_get_active (this_button);
#line 84 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL], 0, number_contained, toggle_active);
#line 229 "number-picker.c"
}

static void
__________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self)
{
#line 81 "../src/number-picker.vala"
	_________lambda5_ ((NumberPicker*) self, _sender);
#line 238 "number-picker.c"
}

static void
_________lambda6_ (NumberPicker* self,
                   GtkWidget* this_button)
{
#line 89 "../src/number-picker.vala"
	g_return_if_fail (this_button != NULL);
#line 90 "../src/number-picker.vala"
	gtk_widget_grab_focus (this_button);
#line 249 "number-picker.c"
}

static void
__________lambda6__gtk_widget_realize (GtkWidget* _sender,
                                       gpointer self)
{
#line 89 "../src/number-picker.vala"
	_________lambda6_ ((NumberPicker*) self, _sender);
#line 258 "number-picker.c"
}

static void
__lambda7_ (NumberPicker* self,
            GtkButton* this_button)
{
	GtkToggleButton** _tmp0_;
	gint _tmp0__length1;
	gboolean _tmp3_;
#line 103 "../src/number-picker.vala"
	g_return_if_fail (this_button != NULL);
#line 104 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_VALUE_PICKED_SIGNAL], 0, 0);
#line 106 "../src/number-picker.vala"
	_tmp0_ = self->priv->earmark_buttons;
#line 106 "../src/number-picker.vala"
	_tmp0__length1 = self->priv->earmark_buttons_length1;
#line 276 "number-picker.c"
	{
		GtkToggleButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 106 "../src/number-picker.vala"
		button_collection = _tmp0_;
#line 106 "../src/number-picker.vala"
		button_collection_length1 = _tmp0__length1;
#line 106 "../src/number-picker.vala"
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
#line 288 "number-picker.c"
			GtkToggleButton* _tmp1_;
			GtkToggleButton* button = NULL;
#line 106 "../src/number-picker.vala"
			_tmp1_ = _g_object_ref0 (button_collection[button_it]);
#line 106 "../src/number-picker.vala"
			button = _tmp1_;
#line 295 "number-picker.c"
			{
				GtkToggleButton* _tmp2_;
#line 107 "../src/number-picker.vala"
				_tmp2_ = button;
#line 107 "../src/number-picker.vala"
				gtk_toggle_button_set_active (_tmp2_, FALSE);
#line 106 "../src/number-picker.vala"
				_g_object_unref0 (button);
#line 304 "number-picker.c"
			}
		}
	}
#line 109 "../src/number-picker.vala"
	_tmp3_ = self->priv->_is_earmark_picker;
#line 109 "../src/number-picker.vala"
	if (_tmp3_) {
#line 110 "../src/number-picker.vala"
		number_picker_set_earmark_buttons_sensitive (self, TRUE);
#line 314 "number-picker.c"
	} else {
#line 112 "../src/number-picker.vala"
		number_picker_set_clear_button_visibility (self, FALSE);
#line 318 "number-picker.c"
	}
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 103 "../src/number-picker.vala"
	__lambda7_ ((NumberPicker*) self, _sender);
#line 328 "number-picker.c"
}

NumberPicker*
number_picker_construct (GType object_type,
                         SudokuGame* game,
                         gboolean for_earmarks)
{
	NumberPicker * self = NULL;
	SudokuBoard* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gboolean _tmp3_;
	GtkButton* _tmp66_;
	GtkButton* _tmp67_;
	GtkButton* _tmp68_;
	GtkLabel* label = NULL;
	gchar* _tmp69_;
	gchar* _tmp70_;
	GtkLabel* _tmp71_;
	GtkLabel* _tmp72_;
	GtkButton* _tmp73_;
	GtkButton* _tmp74_;
#line 37 "../src/number-picker.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 37 "../src/number-picker.vala"
	self = (NumberPicker*) g_object_new (object_type, NULL);
#line 39 "../src/number-picker.vala"
	_tmp0_ = sudoku_game_get_board (game);
#line 39 "../src/number-picker.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/number-picker.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 39 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->board);
#line 39 "../src/number-picker.vala"
	self->priv->board = _tmp2_;
#line 40 "../src/number-picker.vala"
	number_picker_set_is_earmark_picker (self, for_earmarks);
#line 42 "../src/number-picker.vala"
	_tmp3_ = self->priv->_is_earmark_picker;
#line 42 "../src/number-picker.vala"
	if (_tmp3_) {
#line 371 "number-picker.c"
		SudokuBoard* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		SudokuBoard* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		GtkToggleButton** _tmp10_;
#line 43 "../src/number-picker.vala"
		_tmp4_ = self->priv->board;
#line 43 "../src/number-picker.vala"
		_tmp5_ = sudoku_board_get_block_cols (_tmp4_);
#line 43 "../src/number-picker.vala"
		_tmp6_ = _tmp5_;
#line 43 "../src/number-picker.vala"
		_tmp7_ = self->priv->board;
#line 43 "../src/number-picker.vala"
		_tmp8_ = sudoku_board_get_block_rows (_tmp7_);
#line 43 "../src/number-picker.vala"
		_tmp9_ = _tmp8_;
#line 43 "../src/number-picker.vala"
		_tmp10_ = g_new0 (GtkToggleButton*, (_tmp6_ * _tmp9_) + 1);
#line 43 "../src/number-picker.vala"
		self->priv->earmark_buttons = (_vala_array_free (self->priv->earmark_buttons, self->priv->earmark_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 43 "../src/number-picker.vala"
		self->priv->earmark_buttons = _tmp10_;
#line 43 "../src/number-picker.vala"
		self->priv->earmark_buttons_length1 = _tmp6_ * _tmp9_;
#line 43 "../src/number-picker.vala"
		self->priv->_earmark_buttons_size_ = self->priv->earmark_buttons_length1;
#line 401 "number-picker.c"
	} else {
		SudokuBoard* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		SudokuBoard* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		GtkButton** _tmp17_;
#line 45 "../src/number-picker.vala"
		_tmp11_ = self->priv->board;
#line 45 "../src/number-picker.vala"
		_tmp12_ = sudoku_board_get_block_cols (_tmp11_);
#line 45 "../src/number-picker.vala"
		_tmp13_ = _tmp12_;
#line 45 "../src/number-picker.vala"
		_tmp14_ = self->priv->board;
#line 45 "../src/number-picker.vala"
		_tmp15_ = sudoku_board_get_block_rows (_tmp14_);
#line 45 "../src/number-picker.vala"
		_tmp16_ = _tmp15_;
#line 45 "../src/number-picker.vala"
		_tmp17_ = g_new0 (GtkButton*, (_tmp13_ * _tmp16_) + 1);
#line 45 "../src/number-picker.vala"
		self->priv->value_buttons = (_vala_array_free (self->priv->value_buttons, self->priv->value_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 45 "../src/number-picker.vala"
		self->priv->value_buttons = _tmp17_;
#line 45 "../src/number-picker.vala"
		self->priv->value_buttons_length1 = _tmp13_ * _tmp16_;
#line 45 "../src/number-picker.vala"
		self->priv->_value_buttons_size_ = self->priv->value_buttons_length1;
#line 432 "number-picker.c"
	}
	{
		gint col = 0;
#line 47 "../src/number-picker.vala"
		col = 0;
#line 438 "number-picker.c"
		{
			gboolean _tmp18_ = FALSE;
#line 47 "../src/number-picker.vala"
			_tmp18_ = TRUE;
#line 47 "../src/number-picker.vala"
			while (TRUE) {
#line 445 "number-picker.c"
				SudokuBoard* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 47 "../src/number-picker.vala"
				if (!_tmp18_) {
#line 451 "number-picker.c"
					gint _tmp19_;
#line 47 "../src/number-picker.vala"
					_tmp19_ = col;
#line 47 "../src/number-picker.vala"
					col = _tmp19_ + 1;
#line 457 "number-picker.c"
				}
#line 47 "../src/number-picker.vala"
				_tmp18_ = FALSE;
#line 47 "../src/number-picker.vala"
				_tmp20_ = self->priv->board;
#line 47 "../src/number-picker.vala"
				_tmp21_ = sudoku_board_get_block_cols (_tmp20_);
#line 47 "../src/number-picker.vala"
				_tmp22_ = _tmp21_;
#line 47 "../src/number-picker.vala"
				if (!(col < _tmp22_)) {
#line 47 "../src/number-picker.vala"
					break;
#line 471 "number-picker.c"
				}
				{
					gint row = 0;
#line 49 "../src/number-picker.vala"
					row = 0;
#line 477 "number-picker.c"
					{
						gboolean _tmp23_ = FALSE;
#line 49 "../src/number-picker.vala"
						_tmp23_ = TRUE;
#line 49 "../src/number-picker.vala"
						while (TRUE) {
#line 484 "number-picker.c"
							SudokuBoard* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gint n = 0;
							SudokuBoard* _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
							SudokuBoard* _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkButton* _tmp34_ = NULL;
							GtkButton* button = NULL;
							GtkButton* _tmp37_;
							GtkButton* _tmp38_;
							GtkButton* _tmp39_;
							GtkLabel* label = NULL;
							gchar* _tmp40_;
							gchar* _tmp41_;
							GtkLabel* _tmp42_;
							GtkLabel* _tmp43_;
							GtkLabel* _tmp44_;
							gint _tmp45_ = 0;
							GtkLabel* _tmp46_;
							gint _tmp47_ = 0;
							GtkLabel* _tmp48_;
							gint _tmp49_ = 0;
							GtkLabel* _tmp50_;
							gint _tmp51_ = 0;
							GtkLabel* _tmp52_;
							GtkButton* _tmp53_;
							GtkLabel* _tmp54_;
							GtkButton* _tmp55_;
#line 49 "../src/number-picker.vala"
							if (!_tmp23_) {
#line 519 "number-picker.c"
								gint _tmp24_;
#line 49 "../src/number-picker.vala"
								_tmp24_ = row;
#line 49 "../src/number-picker.vala"
								row = _tmp24_ + 1;
#line 525 "number-picker.c"
							}
#line 49 "../src/number-picker.vala"
							_tmp23_ = FALSE;
#line 49 "../src/number-picker.vala"
							_tmp25_ = self->priv->board;
#line 49 "../src/number-picker.vala"
							_tmp26_ = sudoku_board_get_block_rows (_tmp25_);
#line 49 "../src/number-picker.vala"
							_tmp27_ = _tmp26_;
#line 49 "../src/number-picker.vala"
							if (!(row < _tmp27_)) {
#line 49 "../src/number-picker.vala"
								break;
#line 539 "number-picker.c"
							}
#line 51 "../src/number-picker.vala"
							_tmp28_ = self->priv->board;
#line 51 "../src/number-picker.vala"
							_tmp29_ = sudoku_board_get_block_rows (_tmp28_);
#line 51 "../src/number-picker.vala"
							_tmp30_ = _tmp29_;
#line 51 "../src/number-picker.vala"
							_tmp31_ = self->priv->board;
#line 51 "../src/number-picker.vala"
							_tmp32_ = sudoku_board_get_block_cols (_tmp31_);
#line 51 "../src/number-picker.vala"
							_tmp33_ = _tmp32_;
#line 51 "../src/number-picker.vala"
							n = (col + (((_tmp30_ - 1) - row) * _tmp33_)) + 1;
#line 53 "../src/number-picker.vala"
							if (for_earmarks) {
#line 557 "number-picker.c"
								GtkToggleButton* _tmp35_;
#line 53 "../src/number-picker.vala"
								_tmp35_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 53 "../src/number-picker.vala"
								g_object_ref_sink (_tmp35_);
#line 53 "../src/number-picker.vala"
								_g_object_unref0 (_tmp34_);
#line 53 "../src/number-picker.vala"
								_tmp34_ = (GtkButton*) _tmp35_;
#line 567 "number-picker.c"
							} else {
								GtkButton* _tmp36_;
#line 53 "../src/number-picker.vala"
								_tmp36_ = (GtkButton*) gtk_button_new ();
#line 53 "../src/number-picker.vala"
								g_object_ref_sink (_tmp36_);
#line 53 "../src/number-picker.vala"
								_g_object_unref0 (_tmp34_);
#line 53 "../src/number-picker.vala"
								_tmp34_ = _tmp36_;
#line 578 "number-picker.c"
							}
#line 53 "../src/number-picker.vala"
							_tmp37_ = _g_object_ref0 (_tmp34_);
#line 53 "../src/number-picker.vala"
							button = _tmp37_;
#line 54 "../src/number-picker.vala"
							_tmp38_ = button;
#line 54 "../src/number-picker.vala"
							gtk_widget_set_focus_on_click ((GtkWidget*) _tmp38_, FALSE);
#line 55 "../src/number-picker.vala"
							_tmp39_ = button;
#line 55 "../src/number-picker.vala"
							gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp39_, col, row, 1, 1);
#line 57 "../src/number-picker.vala"
							_tmp40_ = g_strdup_printf ("<big>%d</big>", n);
#line 57 "../src/number-picker.vala"
							_tmp41_ = _tmp40_;
#line 57 "../src/number-picker.vala"
							_tmp42_ = (GtkLabel*) gtk_label_new (_tmp41_);
#line 57 "../src/number-picker.vala"
							g_object_ref_sink (_tmp42_);
#line 57 "../src/number-picker.vala"
							_tmp43_ = _tmp42_;
#line 57 "../src/number-picker.vala"
							_g_free0 (_tmp41_);
#line 57 "../src/number-picker.vala"
							label = _tmp43_;
#line 58 "../src/number-picker.vala"
							_tmp44_ = label;
#line 58 "../src/number-picker.vala"
							gtk_label_set_use_markup (_tmp44_, TRUE);
#line 59 "../src/number-picker.vala"
							if (for_earmarks) {
#line 59 "../src/number-picker.vala"
								_tmp45_ = 0;
#line 614 "number-picker.c"
							} else {
#line 59 "../src/number-picker.vala"
								_tmp45_ = 8;
#line 618 "number-picker.c"
							}
#line 59 "../src/number-picker.vala"
							_tmp46_ = label;
#line 59 "../src/number-picker.vala"
							gtk_widget_set_margin_start ((GtkWidget*) _tmp46_, _tmp45_);
#line 60 "../src/number-picker.vala"
							if (for_earmarks) {
#line 60 "../src/number-picker.vala"
								_tmp47_ = 16;
#line 628 "number-picker.c"
							} else {
#line 60 "../src/number-picker.vala"
								_tmp47_ = 8;
#line 632 "number-picker.c"
							}
#line 60 "../src/number-picker.vala"
							_tmp48_ = label;
#line 60 "../src/number-picker.vala"
							gtk_widget_set_margin_end ((GtkWidget*) _tmp48_, _tmp47_);
#line 61 "../src/number-picker.vala"
							if (for_earmarks) {
#line 61 "../src/number-picker.vala"
								_tmp49_ = 0;
#line 642 "number-picker.c"
							} else {
#line 61 "../src/number-picker.vala"
								_tmp49_ = 4;
#line 646 "number-picker.c"
							}
#line 61 "../src/number-picker.vala"
							_tmp50_ = label;
#line 61 "../src/number-picker.vala"
							gtk_widget_set_margin_top ((GtkWidget*) _tmp50_, _tmp49_);
#line 62 "../src/number-picker.vala"
							if (for_earmarks) {
#line 62 "../src/number-picker.vala"
								_tmp51_ = 8;
#line 656 "number-picker.c"
							} else {
#line 62 "../src/number-picker.vala"
								_tmp51_ = 4;
#line 660 "number-picker.c"
							}
#line 62 "../src/number-picker.vala"
							_tmp52_ = label;
#line 62 "../src/number-picker.vala"
							gtk_widget_set_margin_bottom ((GtkWidget*) _tmp52_, _tmp51_);
#line 63 "../src/number-picker.vala"
							_tmp53_ = button;
#line 63 "../src/number-picker.vala"
							_tmp54_ = label;
#line 63 "../src/number-picker.vala"
							gtk_button_set_child (_tmp53_, (GtkWidget*) _tmp54_);
#line 66 "../src/number-picker.vala"
							_tmp55_ = button;
#line 66 "../src/number-picker.vala"
							g_object_set_data_full ((GObject*) _tmp55_, "number-contained", (gpointer) ((gintptr) n), NULL);
#line 68 "../src/number-picker.vala"
							if (!for_earmarks) {
#line 678 "number-picker.c"
								GtkButton** _tmp56_;
								gint _tmp56__length1;
								GtkButton* _tmp57_;
								GtkButton* _tmp58_;
								GtkButton* _tmp59_;
#line 70 "../src/number-picker.vala"
								_tmp56_ = self->priv->value_buttons;
#line 70 "../src/number-picker.vala"
								_tmp56__length1 = self->priv->value_buttons_length1;
#line 70 "../src/number-picker.vala"
								_tmp57_ = button;
#line 70 "../src/number-picker.vala"
								_tmp58_ = _g_object_ref0 (_tmp57_);
#line 70 "../src/number-picker.vala"
								_g_object_unref0 (_tmp56_[n - 1]);
#line 70 "../src/number-picker.vala"
								_tmp56_[n - 1] = _tmp58_;
#line 71 "../src/number-picker.vala"
								_tmp59_ = button;
#line 71 "../src/number-picker.vala"
								g_signal_connect_object (_tmp59_, "clicked", (GCallback) __________lambda4__gtk_button_clicked, self, 0);
#line 700 "number-picker.c"
							} else {
								GtkToggleButton** _tmp60_;
								gint _tmp60__length1;
								GtkButton* _tmp61_;
								GtkToggleButton* _tmp62_;
								GtkToggleButton** _tmp63_;
								gint _tmp63__length1;
								GtkToggleButton* _tmp64_;
#line 80 "../src/number-picker.vala"
								_tmp60_ = self->priv->earmark_buttons;
#line 80 "../src/number-picker.vala"
								_tmp60__length1 = self->priv->earmark_buttons_length1;
#line 80 "../src/number-picker.vala"
								_tmp61_ = button;
#line 80 "../src/number-picker.vala"
								_tmp62_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 80 "../src/number-picker.vala"
								_g_object_unref0 (_tmp60_[n - 1]);
#line 80 "../src/number-picker.vala"
								_tmp60_[n - 1] = _tmp62_;
#line 81 "../src/number-picker.vala"
								_tmp63_ = self->priv->earmark_buttons;
#line 81 "../src/number-picker.vala"
								_tmp63__length1 = self->priv->earmark_buttons_length1;
#line 81 "../src/number-picker.vala"
								_tmp64_ = _tmp63_[n - 1];
#line 81 "../src/number-picker.vala"
								g_signal_connect_object (_tmp64_, "toggled", (GCallback) __________lambda5__gtk_toggle_button_toggled, self, 0);
#line 729 "number-picker.c"
							}
#line 88 "../src/number-picker.vala"
							if (n == 5) {
#line 733 "number-picker.c"
								GtkButton* _tmp65_;
#line 89 "../src/number-picker.vala"
								_tmp65_ = button;
#line 89 "../src/number-picker.vala"
								g_signal_connect_object ((GtkWidget*) _tmp65_, "realize", (GCallback) __________lambda6__gtk_widget_realize, self, 0);
#line 739 "number-picker.c"
							}
#line 49 "../src/number-picker.vala"
							_g_object_unref0 (label);
#line 49 "../src/number-picker.vala"
							_g_object_unref0 (button);
#line 49 "../src/number-picker.vala"
							_g_object_unref0 (_tmp34_);
#line 747 "number-picker.c"
						}
					}
				}
			}
		}
	}
#line 95 "../src/number-picker.vala"
	_tmp66_ = (GtkButton*) gtk_button_new ();
#line 95 "../src/number-picker.vala"
	g_object_ref_sink (_tmp66_);
#line 95 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->clear_button);
#line 95 "../src/number-picker.vala"
	self->priv->clear_button = _tmp66_;
#line 96 "../src/number-picker.vala"
	_tmp67_ = self->priv->clear_button;
#line 96 "../src/number-picker.vala"
	gtk_widget_set_focus_on_click ((GtkWidget*) _tmp67_, FALSE);
#line 97 "../src/number-picker.vala"
	_tmp68_ = self->priv->clear_button;
#line 97 "../src/number-picker.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp68_, 0, 4, 3, 1);
#line 99 "../src/number-picker.vala"
	_tmp69_ = g_strdup_printf ("<big>%s</big>", _ ("Clear"));
#line 99 "../src/number-picker.vala"
	_tmp70_ = _tmp69_;
#line 99 "../src/number-picker.vala"
	_tmp71_ = (GtkLabel*) gtk_label_new (_tmp70_);
#line 99 "../src/number-picker.vala"
	g_object_ref_sink (_tmp71_);
#line 99 "../src/number-picker.vala"
	_tmp72_ = _tmp71_;
#line 99 "../src/number-picker.vala"
	_g_free0 (_tmp70_);
#line 99 "../src/number-picker.vala"
	label = _tmp72_;
#line 100 "../src/number-picker.vala"
	gtk_label_set_use_markup (label, TRUE);
#line 101 "../src/number-picker.vala"
	_tmp73_ = self->priv->clear_button;
#line 101 "../src/number-picker.vala"
	gtk_button_set_child (_tmp73_, (GtkWidget*) label);
#line 103 "../src/number-picker.vala"
	_tmp74_ = self->priv->clear_button;
#line 103 "../src/number-picker.vala"
	g_signal_connect_object (_tmp74_, "clicked", (GCallback) ___lambda7__gtk_button_clicked, self, 0);
#line 115 "../src/number-picker.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 116 "../src/number-picker.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 117 "../src/number-picker.vala"
	gtk_widget_set_margin_top ((GtkWidget*) self, 2);
#line 118 "../src/number-picker.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 2);
#line 119 "../src/number-picker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 2);
#line 120 "../src/number-picker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 2);
#line 121 "../src/number-picker.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 3);
#line 122 "../src/number-picker.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 3);
#line 37 "../src/number-picker.vala"
	_g_object_unref0 (label);
#line 37 "../src/number-picker.vala"
	return self;
#line 814 "number-picker.c"
}

NumberPicker*
number_picker_new (SudokuGame* game,
                   gboolean for_earmarks)
{
#line 37 "../src/number-picker.vala"
	return number_picker_construct (TYPE_NUMBER_PICKER, game, for_earmarks);
#line 823 "number-picker.c"
}

void
number_picker_set_clear_button_visibility (NumberPicker* self,
                                           gboolean visible)
{
	GtkButton* _tmp0_;
#line 125 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/number-picker.vala"
	_tmp0_ = self->priv->clear_button;
#line 127 "../src/number-picker.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, visible);
#line 837 "number-picker.c"
}

void
number_picker_set_clear_button_enabled (NumberPicker* self,
                                        gboolean enabled)
{
	GtkButton* _tmp0_;
#line 130 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/number-picker.vala"
	_tmp0_ = self->priv->clear_button;
#line 132 "../src/number-picker.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, enabled);
#line 851 "number-picker.c"
}

void
number_picker_set_earmark_buttons_sensitive (NumberPicker* self,
                                             gboolean enabled)
{
	GtkToggleButton** _tmp0_;
	gint _tmp0__length1;
#line 135 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/number-picker.vala"
	_tmp0_ = self->priv->earmark_buttons;
#line 137 "../src/number-picker.vala"
	_tmp0__length1 = self->priv->earmark_buttons_length1;
#line 866 "number-picker.c"
	{
		GtkToggleButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 137 "../src/number-picker.vala"
		button_collection = _tmp0_;
#line 137 "../src/number-picker.vala"
		button_collection_length1 = _tmp0__length1;
#line 137 "../src/number-picker.vala"
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
#line 878 "number-picker.c"
			GtkToggleButton* _tmp1_;
			GtkToggleButton* button = NULL;
#line 137 "../src/number-picker.vala"
			_tmp1_ = _g_object_ref0 (button_collection[button_it]);
#line 137 "../src/number-picker.vala"
			button = _tmp1_;
#line 885 "number-picker.c"
			{
				GtkToggleButton* _tmp2_;
#line 138 "../src/number-picker.vala"
				_tmp2_ = button;
#line 138 "../src/number-picker.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, enabled);
#line 137 "../src/number-picker.vala"
				_g_object_unref0 (button);
#line 894 "number-picker.c"
			}
		}
	}
}

void
number_picker_set_earmark_buttons (NumberPicker* self,
                                   gint row,
                                   gint col)
{
	gboolean _tmp0_;
#line 141 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/number-picker.vala"
	_tmp0_ = self->priv->_is_earmark_picker;
#line 141 "../src/number-picker.vala"
	_vala_return_if_fail (_tmp0_, "is_earmark_picker");
#line 912 "number-picker.c"
	{
		gint i = 0;
#line 144 "../src/number-picker.vala"
		i = 1;
#line 917 "number-picker.c"
		{
			gboolean _tmp1_ = FALSE;
#line 144 "../src/number-picker.vala"
			_tmp1_ = TRUE;
#line 144 "../src/number-picker.vala"
			while (TRUE) {
#line 924 "number-picker.c"
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				SudokuBoard* _tmp6_;
#line 144 "../src/number-picker.vala"
				if (!_tmp1_) {
#line 931 "number-picker.c"
					gint _tmp2_;
#line 144 "../src/number-picker.vala"
					_tmp2_ = i;
#line 144 "../src/number-picker.vala"
					i = _tmp2_ + 1;
#line 937 "number-picker.c"
				}
#line 144 "../src/number-picker.vala"
				_tmp1_ = FALSE;
#line 144 "../src/number-picker.vala"
				_tmp3_ = self->priv->board;
#line 144 "../src/number-picker.vala"
				_tmp4_ = sudoku_board_get_max_val (_tmp3_);
#line 144 "../src/number-picker.vala"
				_tmp5_ = _tmp4_;
#line 144 "../src/number-picker.vala"
				if (!(i <= _tmp5_)) {
#line 144 "../src/number-picker.vala"
					break;
#line 951 "number-picker.c"
				}
#line 145 "../src/number-picker.vala"
				_tmp6_ = self->priv->board;
#line 145 "../src/number-picker.vala"
				number_picker_set_earmark_button (self, i, sudoku_board_is_earmark_enabled (_tmp6_, row, col, i));
#line 957 "number-picker.c"
			}
		}
	}
}

void
number_picker_set_earmark_button (NumberPicker* self,
                                  gint num,
                                  gboolean state)
{
	gboolean _tmp0_;
	GtkToggleButton** _tmp1_;
	gint _tmp1__length1;
	GtkToggleButton* _tmp2_;
#line 148 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/number-picker.vala"
	_tmp0_ = self->priv->_is_earmark_picker;
#line 148 "../src/number-picker.vala"
	_vala_return_if_fail (_tmp0_, "is_earmark_picker");
#line 151 "../src/number-picker.vala"
	_tmp1_ = self->priv->earmark_buttons;
#line 151 "../src/number-picker.vala"
	_tmp1__length1 = self->priv->earmark_buttons_length1;
#line 151 "../src/number-picker.vala"
	_tmp2_ = _tmp1_[num - 1];
#line 151 "../src/number-picker.vala"
	gtk_toggle_button_set_active (_tmp2_, state);
#line 986 "number-picker.c"
}

static void
number_picker_real_dispose (GObject* base)
{
	NumberPicker * self;
	GtkButton* _tmp0_;
	GtkToggleButton** _tmp1_;
	gint _tmp1__length1;
	GtkButton** _tmp4_;
	gint _tmp4__length1;
#line 154 "../src/number-picker.vala"
	self = (NumberPicker*) base;
#line 156 "../src/number-picker.vala"
	_tmp0_ = self->priv->clear_button;
#line 156 "../src/number-picker.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 157 "../src/number-picker.vala"
	_tmp1_ = self->priv->earmark_buttons;
#line 157 "../src/number-picker.vala"
	_tmp1__length1 = self->priv->earmark_buttons_length1;
#line 1008 "number-picker.c"
	{
		GtkToggleButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 157 "../src/number-picker.vala"
		button_collection = _tmp1_;
#line 157 "../src/number-picker.vala"
		button_collection_length1 = _tmp1__length1;
#line 157 "../src/number-picker.vala"
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
#line 1020 "number-picker.c"
			GtkToggleButton* _tmp2_;
			GtkToggleButton* button = NULL;
#line 157 "../src/number-picker.vala"
			_tmp2_ = _g_object_ref0 (button_collection[button_it]);
#line 157 "../src/number-picker.vala"
			button = _tmp2_;
#line 1027 "number-picker.c"
			{
				GtkToggleButton* _tmp3_;
#line 158 "../src/number-picker.vala"
				_tmp3_ = button;
#line 158 "../src/number-picker.vala"
				gtk_widget_unparent ((GtkWidget*) _tmp3_);
#line 157 "../src/number-picker.vala"
				_g_object_unref0 (button);
#line 1036 "number-picker.c"
			}
		}
	}
#line 159 "../src/number-picker.vala"
	_tmp4_ = self->priv->value_buttons;
#line 159 "../src/number-picker.vala"
	_tmp4__length1 = self->priv->value_buttons_length1;
#line 1044 "number-picker.c"
	{
		GtkButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 159 "../src/number-picker.vala"
		button_collection = _tmp4_;
#line 159 "../src/number-picker.vala"
		button_collection_length1 = _tmp4__length1;
#line 159 "../src/number-picker.vala"
		for (button_it = 0; button_it < button_collection_length1; button_it = button_it + 1) {
#line 1056 "number-picker.c"
			GtkButton* _tmp5_;
			GtkButton* button = NULL;
#line 159 "../src/number-picker.vala"
			_tmp5_ = _g_object_ref0 (button_collection[button_it]);
#line 159 "../src/number-picker.vala"
			button = _tmp5_;
#line 1063 "number-picker.c"
			{
				GtkButton* _tmp6_;
#line 160 "../src/number-picker.vala"
				_tmp6_ = button;
#line 160 "../src/number-picker.vala"
				gtk_widget_unparent ((GtkWidget*) _tmp6_);
#line 159 "../src/number-picker.vala"
				_g_object_unref0 (button);
#line 1072 "number-picker.c"
			}
		}
	}
}

gboolean
number_picker_get_is_earmark_picker (NumberPicker* self)
{
	gboolean result;
#line 35 "../src/number-picker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../src/number-picker.vala"
	result = self->priv->_is_earmark_picker;
#line 35 "../src/number-picker.vala"
	return result;
#line 1088 "number-picker.c"
}

static void
number_picker_set_is_earmark_picker (NumberPicker* self,
                                     gboolean value)
{
	gboolean old_value;
#line 35 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/number-picker.vala"
	old_value = number_picker_get_is_earmark_picker (self);
#line 35 "../src/number-picker.vala"
	if (old_value != value) {
#line 35 "../src/number-picker.vala"
		self->priv->_is_earmark_picker = value;
#line 35 "../src/number-picker.vala"
		g_object_notify_by_pspec ((GObject *) self, number_picker_properties[NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY]);
#line 1106 "number-picker.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_BOOLEAN) (gpointer data1, gint arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../src/number-picker.vala"
	g_return_if_fail (n_param_values == 3);
#line 24 "../src/number-picker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/number-picker.vala"
		data1 = closure->data;
#line 24 "../src/number-picker.vala"
		data2 = param_values->data[0].v_pointer;
#line 1132 "number-picker.c"
	} else {
#line 24 "../src/number-picker.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/number-picker.vala"
		data2 = closure->data;
#line 1138 "number-picker.c"
	}
#line 24 "../src/number-picker.vala"
	callback = (GMarshalFunc_VOID__INT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/number-picker.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 1144 "number-picker.c"
}

static void
number_picker_class_init (NumberPickerClass * klass,
                          gpointer klass_data)
{
#line 24 "../src/number-picker.vala"
	number_picker_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/number-picker.vala"
	g_type_class_adjust_private_offset (klass, &NumberPicker_private_offset);
#line 24 "../src/number-picker.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) number_picker_real_dispose;
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_number_picker_get_property;
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_number_picker_set_property;
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (klass)->finalize = number_picker_finalize;
#line 24 "../src/number-picker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY, number_picker_properties[NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY] = g_param_spec_boolean ("is-earmark-picker", "is-earmark-picker", "is-earmark-picker", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/number-picker.vala"
	number_picker_signals[NUMBER_PICKER_VALUE_PICKED_SIGNAL] = g_signal_new ("value-picked", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 24 "../src/number-picker.vala"
	number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL] = g_signal_new ("earmark-state-changed", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_BOOLEAN);
#line 1169 "number-picker.c"
}

static void
number_picker_instance_init (NumberPicker * self,
                             gpointer klass)
{
#line 24 "../src/number-picker.vala"
	self->priv = number_picker_get_instance_private (self);
#line 1178 "number-picker.c"
}

static void
number_picker_finalize (GObject * obj)
{
	NumberPicker * self;
#line 24 "../src/number-picker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER_PICKER, NumberPicker);
#line 26 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->board);
#line 31 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->clear_button);
#line 32 "../src/number-picker.vala"
	self->priv->value_buttons = (_vala_array_free (self->priv->value_buttons, self->priv->value_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 33 "../src/number-picker.vala"
	self->priv->earmark_buttons = (_vala_array_free (self->priv->earmark_buttons, self->priv->earmark_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (number_picker_parent_class)->finalize (obj);
#line 1197 "number-picker.c"
}

static GType
number_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NumberPickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NumberPicker), 0, (GInstanceInitFunc) number_picker_instance_init, NULL };
	GType number_picker_type_id;
	number_picker_type_id = g_type_register_static (gtk_grid_get_type (), "NumberPicker", &g_define_type_info, 0);
	NumberPicker_private_offset = g_type_add_instance_private (number_picker_type_id, sizeof (NumberPickerPrivate));
	return number_picker_type_id;
}

GType
number_picker_get_type (void)
{
	static volatile gsize number_picker_type_id__once = 0;
	if (g_once_init_enter (&number_picker_type_id__once)) {
		GType number_picker_type_id;
		number_picker_type_id = number_picker_get_type_once ();
		g_once_init_leave (&number_picker_type_id__once, number_picker_type_id);
	}
	return number_picker_type_id__once;
}

static void
_vala_number_picker_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	NumberPicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER_PICKER, NumberPicker);
#line 24 "../src/number-picker.vala"
	switch (property_id) {
#line 24 "../src/number-picker.vala"
		case NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY:
#line 24 "../src/number-picker.vala"
		g_value_set_boolean (value, number_picker_get_is_earmark_picker (self));
#line 24 "../src/number-picker.vala"
		break;
#line 1238 "number-picker.c"
		default:
#line 24 "../src/number-picker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/number-picker.vala"
		break;
#line 1244 "number-picker.c"
	}
}

static void
_vala_number_picker_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	NumberPicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER_PICKER, NumberPicker);
#line 24 "../src/number-picker.vala"
	switch (property_id) {
#line 24 "../src/number-picker.vala"
		case NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY:
#line 24 "../src/number-picker.vala"
		number_picker_set_is_earmark_picker (self, g_value_get_boolean (value));
#line 24 "../src/number-picker.vala"
		break;
#line 1264 "number-picker.c"
		default:
#line 24 "../src/number-picker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/number-picker.vala"
		break;
#line 1270 "number-picker.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

