/* preferences-dialog.c generated by valac 0.56.17, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2024 Johan Gay
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_PREFERENCES_DIALOG (sudoku_preferences_dialog_get_type ())
#define SUDOKU_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialog))
#define SUDOKU_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialogClass))
#define IS_SUDOKU_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG))
#define IS_SUDOKU_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PREFERENCES_DIALOG))
#define SUDOKU_PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialogClass))

typedef struct _SudokuPreferencesDialog SudokuPreferencesDialog;
typedef struct _SudokuPreferencesDialogClass SudokuPreferencesDialogClass;
typedef struct _SudokuPreferencesDialogPrivate SudokuPreferencesDialogPrivate;

#define TYPE_SUDOKU_WINDOW (sudoku_window_get_type ())
#define SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_WINDOW, SudokuWindow))
#define SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_WINDOW, SudokuWindowClass))
#define IS_SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_WINDOW))
#define IS_SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_WINDOW))
#define SUDOKU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_WINDOW, SudokuWindowClass))

typedef struct _SudokuWindow SudokuWindow;
typedef struct _SudokuWindowClass SudokuWindowClass;
enum  {
	SUDOKU_PREFERENCES_DIALOG_0_PROPERTY,
	SUDOKU_PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* sudoku_preferences_dialog_properties[SUDOKU_PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;
typedef enum  {
	ZOOM_LEVEL_SMALL = 1,
	ZOOM_LEVEL_MEDIUM = 2,
	ZOOM_LEVEL_LARGE = 3
} ZoomLevel;

#define TYPE_ZOOM_LEVEL (zoom_level_get_type ())

struct _SudokuPreferencesDialog {
	AdwPreferencesDialog parent_instance;
	SudokuPreferencesDialogPrivate * priv;
	AdwSwitchRow* autoclean_earmarks;
	AdwSwitchRow* show_possibilities;
	AdwSwitchRow* show_timer;
	AdwSwitchRow* number_picker_second_click;
	AdwSwitchRow* show_earmark_warnings;
	AdwSwitchRow* solution_warnings;
	AdwSwitchRow* highlight_numbers;
	AdwSwitchRow* highlight_block;
	AdwSwitchRow* highlight_row_column;
};

struct _SudokuPreferencesDialogClass {
	AdwPreferencesDialogClass parent_class;
};

struct _SudokuPreferencesDialogPrivate {
	SudokuWindow* window;
};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	gboolean earmark_mode;
	gboolean autoclean_earmarks;
	gboolean number_picker_second_click;
	gboolean highlight_row_column;
	gboolean highlight_block;
	gboolean highlight_numbers;
	gdouble value_zoom_multiplier;
	ZoomLevel zoom_level;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

static gint SudokuPreferencesDialog_private_offset;
static gpointer sudoku_preferences_dialog_parent_class = NULL;

VALA_EXTERN GType sudoku_preferences_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuPreferencesDialog, g_object_unref)
VALA_EXTERN GType sudoku_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuWindow, g_object_unref)
VALA_EXTERN SudokuPreferencesDialog* sudoku_preferences_dialog_new (SudokuWindow* window);
VALA_EXTERN SudokuPreferencesDialog* sudoku_preferences_dialog_construct (GType object_type,
                                                              SudokuWindow* window);
VALA_EXTERN GSettings* sudoku_window_get_settings (SudokuWindow* self);
static void __lambda26_ (SudokuPreferencesDialog* self);
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN SudokuView* sudoku_window_get_view (SudokuWindow* self);
VALA_EXTERN void sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                            gboolean value);
static void ___lambda26__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda27_ (SudokuPreferencesDialog* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
static void ___lambda27__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda28_ (SudokuPreferencesDialog* self);
VALA_EXTERN GType zoom_level_get_type (void) G_GNUC_CONST ;
static void ___lambda28__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda29_ (SudokuPreferencesDialog* self);
static void ___lambda29__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda30_ (SudokuPreferencesDialog* self);
VALA_EXTERN void sudoku_view_set_solution_warnings (SudokuView* self,
                                        gboolean value);
static void ___lambda30__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda31_ (SudokuPreferencesDialog* self);
VALA_EXTERN void sudoku_window_set_show_timer (SudokuWindow* self,
                                   gboolean value);
static void ___lambda31__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda32_ (SudokuPreferencesDialog* self);
static void ___lambda32__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda33_ (SudokuPreferencesDialog* self);
static void ___lambda33__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda34_ (SudokuPreferencesDialog* self);
static void ___lambda34__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sudoku_preferences_dialog_real_dispose (GObject* base);
static void sudoku_preferences_dialog_finalize (GObject * obj);
static GType sudoku_preferences_dialog_get_type_once (void);

static inline gpointer
sudoku_preferences_dialog_get_instance_private (SudokuPreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuPreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/preferences-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 209 "preferences-dialog.c"
}

static void
__lambda26_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
#line 54 "../src/preferences-dialog.vala"
	_tmp0_ = self->show_earmark_warnings;
#line 54 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 55 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 55 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 55 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 55 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "show-earmark-warnings", value);
#line 56 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 56 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_view (_tmp4_);
#line 56 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 56 "../src/preferences-dialog.vala"
	if (_tmp6_ != NULL) {
#line 243 "preferences-dialog.c"
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
#line 57 "../src/preferences-dialog.vala"
		_tmp7_ = self->priv->window;
#line 57 "../src/preferences-dialog.vala"
		_tmp8_ = sudoku_window_get_view (_tmp7_);
#line 57 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 57 "../src/preferences-dialog.vala"
		sudoku_view_set_show_earmark_warnings (_tmp9_, value);
#line 255 "preferences-dialog.c"
	}
}

static void
___lambda26__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 53 "../src/preferences-dialog.vala"
	__lambda26_ ((SudokuPreferencesDialog*) self);
#line 266 "preferences-dialog.c"
}

static void
__lambda27_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
#line 61 "../src/preferences-dialog.vala"
	_tmp0_ = self->show_possibilities;
#line 61 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 62 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 62 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 62 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 62 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "show-possibilities", value);
#line 63 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 63 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_view (_tmp4_);
#line 63 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 63 "../src/preferences-dialog.vala"
	if (_tmp6_ != NULL) {
#line 300 "preferences-dialog.c"
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
#line 64 "../src/preferences-dialog.vala"
		_tmp7_ = self->priv->window;
#line 64 "../src/preferences-dialog.vala"
		_tmp8_ = sudoku_window_get_view (_tmp7_);
#line 64 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 64 "../src/preferences-dialog.vala"
		sudoku_view_set_show_possibilities (_tmp9_, value);
#line 312 "preferences-dialog.c"
	}
}

static void
___lambda27__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 60 "../src/preferences-dialog.vala"
	__lambda27_ ((SudokuPreferencesDialog*) self);
#line 323 "preferences-dialog.c"
}

static void
__lambda28_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
#line 68 "../src/preferences-dialog.vala"
	_tmp0_ = self->autoclean_earmarks;
#line 68 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 69 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 69 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 69 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 69 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "autoclean-earmarks", value);
#line 70 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 70 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_view (_tmp4_);
#line 70 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 70 "../src/preferences-dialog.vala"
	if (_tmp6_ != NULL) {
#line 357 "preferences-dialog.c"
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
#line 71 "../src/preferences-dialog.vala"
		_tmp7_ = self->priv->window;
#line 71 "../src/preferences-dialog.vala"
		_tmp8_ = sudoku_window_get_view (_tmp7_);
#line 71 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 71 "../src/preferences-dialog.vala"
		_tmp9_->autoclean_earmarks = value;
#line 369 "preferences-dialog.c"
	}
}

static void
___lambda28__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 67 "../src/preferences-dialog.vala"
	__lambda28_ ((SudokuPreferencesDialog*) self);
#line 380 "preferences-dialog.c"
}

static void
__lambda29_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
#line 75 "../src/preferences-dialog.vala"
	_tmp0_ = self->number_picker_second_click;
#line 75 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 76 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 76 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 76 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 76 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "number-picker-second-click", value);
#line 77 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 77 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_view (_tmp4_);
#line 77 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 77 "../src/preferences-dialog.vala"
	if (_tmp6_ != NULL) {
#line 414 "preferences-dialog.c"
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
#line 78 "../src/preferences-dialog.vala"
		_tmp7_ = self->priv->window;
#line 78 "../src/preferences-dialog.vala"
		_tmp8_ = sudoku_window_get_view (_tmp7_);
#line 78 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 78 "../src/preferences-dialog.vala"
		_tmp9_->number_picker_second_click = value;
#line 426 "preferences-dialog.c"
	}
}

static void
___lambda29__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 74 "../src/preferences-dialog.vala"
	__lambda29_ ((SudokuPreferencesDialog*) self);
#line 437 "preferences-dialog.c"
}

static void
__lambda30_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
#line 82 "../src/preferences-dialog.vala"
	_tmp0_ = self->solution_warnings;
#line 82 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 83 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 83 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 83 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 83 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "solution-warnings", value);
#line 84 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 84 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_view (_tmp4_);
#line 84 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 84 "../src/preferences-dialog.vala"
	if (_tmp6_ != NULL) {
#line 471 "preferences-dialog.c"
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
#line 85 "../src/preferences-dialog.vala"
		_tmp7_ = self->priv->window;
#line 85 "../src/preferences-dialog.vala"
		_tmp8_ = sudoku_window_get_view (_tmp7_);
#line 85 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 85 "../src/preferences-dialog.vala"
		sudoku_view_set_solution_warnings (_tmp9_, value);
#line 483 "preferences-dialog.c"
	}
}

static void
___lambda30__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 81 "../src/preferences-dialog.vala"
	__lambda30_ ((SudokuPreferencesDialog*) self);
#line 494 "preferences-dialog.c"
}

static void
__lambda31_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
#line 89 "../src/preferences-dialog.vala"
	_tmp0_ = self->show_timer;
#line 89 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 90 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 90 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 90 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 90 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "show-timer", value);
#line 91 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 91 "../src/preferences-dialog.vala"
	sudoku_window_set_show_timer (_tmp4_, value);
#line 522 "preferences-dialog.c"
}

static void
___lambda31__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 88 "../src/preferences-dialog.vala"
	__lambda31_ ((SudokuPreferencesDialog*) self);
#line 532 "preferences-dialog.c"
}

static void
__lambda32_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
#line 95 "../src/preferences-dialog.vala"
	_tmp0_ = self->highlight_row_column;
#line 95 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 96 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 96 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 96 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 96 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "highlight-row-column", value);
#line 97 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 97 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_view (_tmp4_);
#line 97 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 97 "../src/preferences-dialog.vala"
	if (_tmp6_ != NULL) {
#line 566 "preferences-dialog.c"
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
#line 98 "../src/preferences-dialog.vala"
		_tmp7_ = self->priv->window;
#line 98 "../src/preferences-dialog.vala"
		_tmp8_ = sudoku_window_get_view (_tmp7_);
#line 98 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 98 "../src/preferences-dialog.vala"
		_tmp9_->highlight_row_column = value;
#line 578 "preferences-dialog.c"
	}
}

static void
___lambda32__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 94 "../src/preferences-dialog.vala"
	__lambda32_ ((SudokuPreferencesDialog*) self);
#line 589 "preferences-dialog.c"
}

static void
__lambda33_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
#line 102 "../src/preferences-dialog.vala"
	_tmp0_ = self->highlight_block;
#line 102 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 103 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 103 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 103 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 103 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "highlight-block", value);
#line 104 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 104 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_view (_tmp4_);
#line 104 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 104 "../src/preferences-dialog.vala"
	if (_tmp6_ != NULL) {
#line 623 "preferences-dialog.c"
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
#line 105 "../src/preferences-dialog.vala"
		_tmp7_ = self->priv->window;
#line 105 "../src/preferences-dialog.vala"
		_tmp8_ = sudoku_window_get_view (_tmp7_);
#line 105 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 105 "../src/preferences-dialog.vala"
		_tmp9_->highlight_block = value;
#line 635 "preferences-dialog.c"
	}
}

static void
___lambda33__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 101 "../src/preferences-dialog.vala"
	__lambda33_ ((SudokuPreferencesDialog*) self);
#line 646 "preferences-dialog.c"
}

static void
__lambda34_ (SudokuPreferencesDialog* self)
{
	gboolean value = FALSE;
	AdwSwitchRow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	SudokuWindow* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
#line 109 "../src/preferences-dialog.vala"
	_tmp0_ = self->highlight_numbers;
#line 109 "../src/preferences-dialog.vala"
	value = adw_switch_row_get_active (_tmp0_);
#line 110 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 110 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 110 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 110 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_tmp3_, "highlight-numbers", value);
#line 111 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->window;
#line 111 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_view (_tmp4_);
#line 111 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 111 "../src/preferences-dialog.vala"
	if (_tmp6_ != NULL) {
#line 680 "preferences-dialog.c"
		SudokuWindow* _tmp7_;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
#line 112 "../src/preferences-dialog.vala"
		_tmp7_ = self->priv->window;
#line 112 "../src/preferences-dialog.vala"
		_tmp8_ = sudoku_window_get_view (_tmp7_);
#line 112 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 112 "../src/preferences-dialog.vala"
		_tmp9_->highlight_numbers = value;
#line 692 "preferences-dialog.c"
	}
}

static void
___lambda34__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 108 "../src/preferences-dialog.vala"
	__lambda34_ ((SudokuPreferencesDialog*) self);
#line 703 "preferences-dialog.c"
}

SudokuPreferencesDialog*
sudoku_preferences_dialog_construct (GType object_type,
                                     SudokuWindow* window)
{
	SudokuPreferencesDialog * self = NULL;
	SudokuWindow* _tmp0_;
	AdwSwitchRow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	AdwSwitchRow* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	AdwSwitchRow* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	AdwSwitchRow* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	AdwSwitchRow* _tmp13_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	AdwSwitchRow* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	AdwSwitchRow* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	AdwSwitchRow* _tmp22_;
	GSettings* _tmp23_;
	GSettings* _tmp24_;
	AdwSwitchRow* _tmp25_;
	GSettings* _tmp26_;
	GSettings* _tmp27_;
	AdwSwitchRow* _tmp28_;
	AdwSwitchRow* _tmp29_;
	AdwSwitchRow* _tmp30_;
	AdwSwitchRow* _tmp31_;
	AdwSwitchRow* _tmp32_;
	AdwSwitchRow* _tmp33_;
	AdwSwitchRow* _tmp34_;
	AdwSwitchRow* _tmp35_;
	AdwSwitchRow* _tmp36_;
#line 39 "../src/preferences-dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 39 "../src/preferences-dialog.vala"
	self = (SudokuPreferencesDialog*) g_object_new (object_type, NULL);
#line 41 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 41 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->window);
#line 41 "../src/preferences-dialog.vala"
	self->priv->window = _tmp0_;
#line 43 "../src/preferences-dialog.vala"
	_tmp1_ = self->show_timer;
#line 43 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (window);
#line 43 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp1_, g_settings_get_boolean (_tmp3_, "show-timer"));
#line 44 "../src/preferences-dialog.vala"
	_tmp4_ = self->show_earmark_warnings;
#line 44 "../src/preferences-dialog.vala"
	_tmp5_ = sudoku_window_get_settings (window);
#line 44 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 44 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp4_, g_settings_get_boolean (_tmp6_, "show-earmark-warnings"));
#line 45 "../src/preferences-dialog.vala"
	_tmp7_ = self->show_possibilities;
#line 45 "../src/preferences-dialog.vala"
	_tmp8_ = sudoku_window_get_settings (window);
#line 45 "../src/preferences-dialog.vala"
	_tmp9_ = _tmp8_;
#line 45 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp7_, g_settings_get_boolean (_tmp9_, "show-possibilities"));
#line 46 "../src/preferences-dialog.vala"
	_tmp10_ = self->number_picker_second_click;
#line 46 "../src/preferences-dialog.vala"
	_tmp11_ = sudoku_window_get_settings (window);
#line 46 "../src/preferences-dialog.vala"
	_tmp12_ = _tmp11_;
#line 46 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp10_, g_settings_get_boolean (_tmp12_, "number-picker-second-click"));
#line 47 "../src/preferences-dialog.vala"
	_tmp13_ = self->solution_warnings;
#line 47 "../src/preferences-dialog.vala"
	_tmp14_ = sudoku_window_get_settings (window);
#line 47 "../src/preferences-dialog.vala"
	_tmp15_ = _tmp14_;
#line 47 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp13_, g_settings_get_boolean (_tmp15_, "solution-warnings"));
#line 48 "../src/preferences-dialog.vala"
	_tmp16_ = self->autoclean_earmarks;
#line 48 "../src/preferences-dialog.vala"
	_tmp17_ = sudoku_window_get_settings (window);
#line 48 "../src/preferences-dialog.vala"
	_tmp18_ = _tmp17_;
#line 48 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp16_, g_settings_get_boolean (_tmp18_, "autoclean-earmarks"));
#line 49 "../src/preferences-dialog.vala"
	_tmp19_ = self->highlight_row_column;
#line 49 "../src/preferences-dialog.vala"
	_tmp20_ = sudoku_window_get_settings (window);
#line 49 "../src/preferences-dialog.vala"
	_tmp21_ = _tmp20_;
#line 49 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp19_, g_settings_get_boolean (_tmp21_, "highlight-row-column"));
#line 50 "../src/preferences-dialog.vala"
	_tmp22_ = self->highlight_block;
#line 50 "../src/preferences-dialog.vala"
	_tmp23_ = sudoku_window_get_settings (window);
#line 50 "../src/preferences-dialog.vala"
	_tmp24_ = _tmp23_;
#line 50 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp22_, g_settings_get_boolean (_tmp24_, "highlight-block"));
#line 51 "../src/preferences-dialog.vala"
	_tmp25_ = self->highlight_numbers;
#line 51 "../src/preferences-dialog.vala"
	_tmp26_ = sudoku_window_get_settings (window);
#line 51 "../src/preferences-dialog.vala"
	_tmp27_ = _tmp26_;
#line 51 "../src/preferences-dialog.vala"
	adw_switch_row_set_active (_tmp25_, g_settings_get_boolean (_tmp27_, "highlight-numbers"));
#line 53 "../src/preferences-dialog.vala"
	_tmp28_ = self->show_earmark_warnings;
#line 53 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp28_, "notify::active", (GCallback) ___lambda26__g_object_notify, self, 0);
#line 60 "../src/preferences-dialog.vala"
	_tmp29_ = self->show_possibilities;
#line 60 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp29_, "notify::active", (GCallback) ___lambda27__g_object_notify, self, 0);
#line 67 "../src/preferences-dialog.vala"
	_tmp30_ = self->autoclean_earmarks;
#line 67 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp30_, "notify::active", (GCallback) ___lambda28__g_object_notify, self, 0);
#line 74 "../src/preferences-dialog.vala"
	_tmp31_ = self->number_picker_second_click;
#line 74 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp31_, "notify::active", (GCallback) ___lambda29__g_object_notify, self, 0);
#line 81 "../src/preferences-dialog.vala"
	_tmp32_ = self->solution_warnings;
#line 81 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp32_, "notify::active", (GCallback) ___lambda30__g_object_notify, self, 0);
#line 88 "../src/preferences-dialog.vala"
	_tmp33_ = self->show_timer;
#line 88 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp33_, "notify::active", (GCallback) ___lambda31__g_object_notify, self, 0);
#line 94 "../src/preferences-dialog.vala"
	_tmp34_ = self->highlight_row_column;
#line 94 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp34_, "notify::active", (GCallback) ___lambda32__g_object_notify, self, 0);
#line 101 "../src/preferences-dialog.vala"
	_tmp35_ = self->highlight_block;
#line 101 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp35_, "notify::active", (GCallback) ___lambda33__g_object_notify, self, 0);
#line 108 "../src/preferences-dialog.vala"
	_tmp36_ = self->highlight_numbers;
#line 108 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp36_, "notify::active", (GCallback) ___lambda34__g_object_notify, self, 0);
#line 39 "../src/preferences-dialog.vala"
	return self;
#line 868 "preferences-dialog.c"
}

SudokuPreferencesDialog*
sudoku_preferences_dialog_new (SudokuWindow* window)
{
#line 39 "../src/preferences-dialog.vala"
	return sudoku_preferences_dialog_construct (TYPE_SUDOKU_PREFERENCES_DIALOG, window);
#line 876 "preferences-dialog.c"
}

static void
sudoku_preferences_dialog_real_dispose (GObject* base)
{
	SudokuPreferencesDialog * self;
#line 116 "../src/preferences-dialog.vala"
	self = (SudokuPreferencesDialog*) base;
#line 118 "../src/preferences-dialog.vala"
	gtk_widget_dispose_template ((GtkWidget*) self, G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 119 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (sudoku_preferences_dialog_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_preferences_dialog_get_type (), AdwPreferencesDialog));
#line 889 "preferences-dialog.c"
}

static void
sudoku_preferences_dialog_class_init (SudokuPreferencesDialogClass * klass,
                                      gpointer klass_data)
{
#line 25 "../src/preferences-dialog.vala"
	sudoku_preferences_dialog_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &SudokuPreferencesDialog_private_offset);
#line 25 "../src/preferences-dialog.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_preferences_dialog_real_dispose;
#line 25 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_preferences_dialog_finalize;
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/preferences-dialog.ui");
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "autoclean_earmarks", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, autoclean_earmarks));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_possibilities", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_possibilities));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_timer", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_timer));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "number_picker_second_click", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, number_picker_second_click));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_earmark_warnings", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_earmark_warnings));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "solution_warnings", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, solution_warnings));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_numbers", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_numbers));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_block", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_block));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_row_column", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_row_column));
#line 924 "preferences-dialog.c"
}

static void
sudoku_preferences_dialog_instance_init (SudokuPreferencesDialog * self,
                                         gpointer klass)
{
#line 25 "../src/preferences-dialog.vala"
	self->priv = sudoku_preferences_dialog_get_instance_private (self);
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 935 "preferences-dialog.c"
}

static void
sudoku_preferences_dialog_finalize (GObject * obj)
{
	SudokuPreferencesDialog * self;
#line 25 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialog);
#line 37 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->window);
#line 25 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (sudoku_preferences_dialog_parent_class)->finalize (obj);
#line 948 "preferences-dialog.c"
}

static GType
sudoku_preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuPreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuPreferencesDialog), 0, (GInstanceInitFunc) sudoku_preferences_dialog_instance_init, NULL };
	GType sudoku_preferences_dialog_type_id;
	sudoku_preferences_dialog_type_id = g_type_register_static (adw_preferences_dialog_get_type (), "SudokuPreferencesDialog", &g_define_type_info, 0);
	SudokuPreferencesDialog_private_offset = g_type_add_instance_private (sudoku_preferences_dialog_type_id, sizeof (SudokuPreferencesDialogPrivate));
	return sudoku_preferences_dialog_type_id;
}

GType
sudoku_preferences_dialog_get_type (void)
{
	static volatile gsize sudoku_preferences_dialog_type_id__once = 0;
	if (g_once_init_enter (&sudoku_preferences_dialog_type_id__once)) {
		GType sudoku_preferences_dialog_type_id;
		sudoku_preferences_dialog_type_id = sudoku_preferences_dialog_get_type_once ();
		g_once_init_leave (&sudoku_preferences_dialog_type_id__once, sudoku_preferences_dialog_type_id);
	}
	return sudoku_preferences_dialog_type_id__once;
}

