/* sudoku-view.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;
typedef enum  {
	ZOOM_LEVEL_SMALL = 1,
	ZOOM_LEVEL_MEDIUM = 2,
	ZOOM_LEVEL_LARGE = 3
} ZoomLevel;

#define TYPE_ZOOM_LEVEL (zoom_level_get_type ())

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_HAS_SELECTION_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL,
	SUDOKU_VIEW_NUM_SIGNALS
};
static guint sudoku_view_signals[SUDOKU_VIEW_NUM_SIGNALS] = {0};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	gboolean earmark_mode;
	gboolean autoclean_earmarks;
	gboolean number_picker_second_click;
	gboolean highlight_row_column;
	gboolean highlight_block;
	gboolean highlight_numbers;
	gdouble value_zoom_multiplier;
	ZoomLevel zoom_level;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	GSettings* settings;
	SudokuGame* game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	SudokuFrame* frame;
	GtkLabel* paused_label;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_earmark_warnings;
	gboolean _solution_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
	gboolean _has_selection;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType zoom_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
VALA_EXTERN void sudoku_view_update_zoom (SudokuView* self,
                              ZoomLevel level);
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void __lambda8_ (SudokuView* self);
static void sudoku_view_mask_view (SudokuView* self);
static void sudoku_view_clear_all_warnings (SudokuView* self);
static void sudoku_view_unmask_view (SudokuView* self);
static void sudoku_view_update_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda8__sudoku_game_paused_changed (SudokuGame* _sender,
                                             gpointer self);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
VALA_EXTERN void sudoku_cell_get_visible_earmarks (SudokuCell* self);
static void sudoku_view_value_changed_cb (SudokuView* self,
                                   gint row,
                                   gint col,
                                   gint old_val,
                                   gint new_val);
static void _sudoku_view_value_changed_cb_sudoku_board_value_changed (SudokuBoard* _sender,
                                                               gint row,
                                                               gint col,
                                                               gint old_val,
                                                               gint new_val,
                                                               gpointer self);
static void sudoku_view_earmark_changed_cb (SudokuView* self,
                                     gint row,
                                     gint col,
                                     gint num,
                                     gboolean enabled);
static void _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                                   gint row,
                                                                   gint col,
                                                                   gint num,
                                                                   gboolean enabled,
                                                                   gpointer self);
static void sudoku_view_selection_changed_cb (SudokuView* self,
                                       gint old_row,
                                       gint old_col,
                                       gint new_row,
                                       gint new_col);
static void _sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                      gint old_row,
                                                                      gint old_col,
                                                                      gint new_row,
                                                                      gint new_col,
                                                                      gpointer self);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
static void sudoku_view_set_cell_highlighter (SudokuView* self,
                                       gint row,
                                       gint col,
                                       gboolean enabled);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
static void sudoku_view_set_selected_value_highlighter (SudokuView* self,
                                                 gint val,
                                                 gboolean enabled);
static void sudoku_view_set_unselected_value_highlighter (SudokuView* self,
                                                   gint row,
                                                   gint col,
                                                   gint val,
                                                   gboolean enabled);
VALA_EXTERN void sudoku_cell_get_visible_earmark (SudokuCell* self,
                                      gint num);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num);
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlight_number (SudokuCell* self,
                                       gboolean value);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlight_coord (SudokuCell* self,
                                      gboolean value);
VALA_EXTERN void sudoku_cell_check_value_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_earmarks_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_paused (SudokuCell* self,
                             gboolean value);
VALA_EXTERN void sudoku_view_dismiss_popovers (SudokuView* self);
static void sudoku_view_real_dispose (GObject* base);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_earmark_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                            gboolean value);
VALA_EXTERN gboolean sudoku_view_get_solution_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_solution_warnings (SudokuView* self,
                                        gboolean value);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
VALA_EXTERN gboolean sudoku_view_get_has_selection (SudokuView* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static gboolean _sudoku_view___lambda9_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda9__gtk_shortcut_func (GtkWidget* widget,
                                                     GVariant* args,
                                                     gpointer self);
static gboolean _sudoku_view___lambda10_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda10__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda11_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda11__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda12_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda12__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
VALA_EXTERN gboolean zoom_level_is_fully_zoomed_out (ZoomLevel self);
VALA_EXTERN gboolean zoom_level_is_fully_zoomed_in (ZoomLevel self);
VALA_EXTERN ZoomLevel zoom_level_zoom_in (ZoomLevel self);
VALA_EXTERN ZoomLevel zoom_level_zoom_out (ZoomLevel self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 338 "sudoku-view.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 85 "../src/sudoku-view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 346 "sudoku-view.c"
}

static void
__lambda8_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	GtkLabel* _tmp9_;
	SudokuGame* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	SudokuGame* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	SudokuGame* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
#line 85 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->paused_label;
#line 85 "../src/sudoku-view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 85 "../src/sudoku-view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 85 "../src/sudoku-view.vala"
	attr_list = _tmp2_;
#line 86 "../src/sudoku-view.vala"
	_tmp3_ = attr_list;
#line 86 "../src/sudoku-view.vala"
	if (_tmp3_ == NULL) {
#line 383 "sudoku-view.c"
		PangoAttrList* _tmp4_;
#line 87 "../src/sudoku-view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 87 "../src/sudoku-view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 87 "../src/sudoku-view.vala"
		attr_list = _tmp4_;
#line 391 "sudoku-view.c"
	}
#line 89 "../src/sudoku-view.vala"
	_tmp5_ = attr_list;
#line 89 "../src/sudoku-view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 89 "../src/sudoku-view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 93 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->paused_label;
#line 93 "../src/sudoku-view.vala"
	_tmp8_ = attr_list;
#line 93 "../src/sudoku-view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 94 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->paused_label;
#line 94 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->game;
#line 94 "../src/sudoku-view.vala"
	_tmp11_ = sudoku_game_get_paused (_tmp10_);
#line 94 "../src/sudoku-view.vala"
	_tmp12_ = _tmp11_;
#line 94 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, _tmp12_);
#line 96 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->game;
#line 96 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_game_get_paused (_tmp13_);
#line 96 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 96 "../src/sudoku-view.vala"
	if (_tmp15_) {
#line 98 "../src/sudoku-view.vala"
		sudoku_view_mask_view (self);
#line 99 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 427 "sudoku-view.c"
	} else {
#line 103 "../src/sudoku-view.vala"
		sudoku_view_unmask_view (self);
#line 104 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 433 "sudoku-view.c"
	}
#line 107 "../src/sudoku-view.vala"
	_tmp16_ = self->priv->game;
#line 107 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_game_get_paused (_tmp16_);
#line 107 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 107 "../src/sudoku-view.vala"
	sudoku_view_set_has_selection (self, !_tmp18_);
#line 83 "../src/sudoku-view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 445 "sudoku-view.c"
}

static void
___lambda8__sudoku_game_paused_changed (SudokuGame* _sender,
                                        gpointer self)
{
#line 83 "../src/sudoku-view.vala"
	__lambda8_ ((SudokuView*) self);
#line 454 "sudoku-view.c"
}

static void
_sudoku_view_value_changed_cb_sudoku_board_value_changed (SudokuBoard* _sender,
                                                          gint row,
                                                          gint col,
                                                          gint old_val,
                                                          gint new_val,
                                                          gpointer self)
{
#line 150 "../src/sudoku-view.vala"
	sudoku_view_value_changed_cb ((SudokuView*) self, row, col, old_val, new_val);
#line 467 "sudoku-view.c"
}

static void
_sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                              gint row,
                                                              gint col,
                                                              gint num,
                                                              gboolean enabled,
                                                              gpointer self)
{
#line 151 "../src/sudoku-view.vala"
	sudoku_view_earmark_changed_cb ((SudokuView*) self, row, col, num, enabled);
#line 480 "sudoku-view.c"
}

static void
_sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                 gint old_row,
                                                                 gint old_col,
                                                                 gint new_row,
                                                                 gint new_col,
                                                                 gpointer self)
{
#line 152 "../src/sudoku-view.vala"
	sudoku_view_selection_changed_cb ((SudokuView*) self, old_row, old_col, new_row, new_col);
#line 493 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game,
                       GSettings* settings)
{
	SudokuView * self = NULL;
	SudokuGame* _tmp0_;
	GSettings* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp4_;
	GtkOverlay* _tmp5_;
	SudokuFrame* _tmp6_;
	SudokuFrame* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkOverlay* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* _tmp12_;
	SudokuGame* _tmp13_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp14_ = NULL;
	GtkGrid* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkGrid* _tmp17_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp18_;
	SudokuBoard* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	SudokuBoard* _tmp22_;
	SudokuBoard* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GtkGrid** _tmp26_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp50_;
	SudokuBoard* _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	SudokuBoard* _tmp54_;
	SudokuBoard* _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
	SudokuCell** _tmp58_;
	SudokuGame* _tmp95_;
	SudokuBoard* _tmp96_;
	SudokuBoard* _tmp97_;
	SudokuGame* _tmp98_;
	SudokuBoard* _tmp99_;
	SudokuBoard* _tmp100_;
	gboolean _tmp101_ = FALSE;
	gboolean _tmp102_ = FALSE;
	gboolean _tmp103_;
	gboolean _tmp104_;
#line 48 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 48 "../src/sudoku-view.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 48 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 50 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 50 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 50 "../src/sudoku-view.vala"
	self->priv->game = _tmp0_;
#line 51 "../src/sudoku-view.vala"
	_tmp1_ = _g_object_ref0 (settings);
#line 51 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->settings);
#line 51 "../src/sudoku-view.vala"
	self->priv->settings = _tmp1_;
#line 53 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 54 "../src/sudoku-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 55 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 57 "../src/sudoku-view.vala"
	_tmp2_ = sudoku_game_get_mode (game);
#line 57 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 57 "../src/sudoku-view.vala"
	if (_tmp3_ == GAME_MODE_CREATE) {
#line 58 "../src/sudoku-view.vala"
		self->priv->_show_warnings = TRUE;
#line 585 "sudoku-view.c"
	} else {
#line 60 "../src/sudoku-view.vala"
		self->priv->_show_warnings = g_settings_get_boolean (settings, "show-warnings");
#line 589 "sudoku-view.c"
	}
#line 61 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = g_settings_get_boolean (settings, "show-possibilities");
#line 62 "../src/sudoku-view.vala"
	self->priv->_solution_warnings = g_settings_get_boolean (settings, "solution-warnings");
#line 63 "../src/sudoku-view.vala"
	self->priv->_show_earmark_warnings = g_settings_get_boolean (settings, "show-earmark-warnings");
#line 64 "../src/sudoku-view.vala"
	self->priv->_highlighter = g_settings_get_boolean (settings, "highlighter");
#line 65 "../src/sudoku-view.vala"
	self->number_picker_second_click = g_settings_get_boolean (settings, "number-picker-second-click");
#line 66 "../src/sudoku-view.vala"
	self->autoclean_earmarks = g_settings_get_boolean (settings, "autoclean-earmarks");
#line 67 "../src/sudoku-view.vala"
	self->highlight_row_column = g_settings_get_boolean (settings, "highlight-row-column");
#line 68 "../src/sudoku-view.vala"
	self->highlight_block = g_settings_get_boolean (settings, "highlight-block");
#line 69 "../src/sudoku-view.vala"
	self->highlight_numbers = g_settings_get_boolean (settings, "highlight-numbers");
#line 70 "../src/sudoku-view.vala"
	self->zoom_level = (ZoomLevel) g_settings_get_enum (settings, "zoom-level");
#line 72 "../src/sudoku-view.vala"
	sudoku_view_update_zoom (self, self->zoom_level);
#line 74 "../src/sudoku-view.vala"
	_tmp4_ = (GtkOverlay*) gtk_overlay_new ();
#line 74 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp4_);
#line 74 "../src/sudoku-view.vala"
	overlay = _tmp4_;
#line 75 "../src/sudoku-view.vala"
	_tmp5_ = overlay;
#line 75 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_frame_new ((GtkWidget*) _tmp5_);
#line 75 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp6_);
#line 75 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->frame);
#line 75 "../src/sudoku-view.vala"
	self->priv->frame = _tmp6_;
#line 76 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->frame;
#line 76 "../src/sudoku-view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp7_);
#line 78 "../src/sudoku-view.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Paused"));
#line 78 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp8_);
#line 78 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 78 "../src/sudoku-view.vala"
	self->priv->paused_label = _tmp8_;
#line 79 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->paused_label;
#line 79 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 80 "../src/sudoku-view.vala"
	_tmp10_ = overlay;
#line 80 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->paused_label;
#line 80 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp10_, (GtkWidget*) _tmp11_);
#line 81 "../src/sudoku-view.vala"
	_tmp12_ = overlay;
#line 81 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "paused");
#line 83 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->game;
#line 83 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp13_, "paused-changed", (GCallback) ___lambda8__sudoku_game_paused_changed, self, 0);
#line 110 "../src/sudoku-view.vala"
	_tmp14_ = (GtkGrid*) gtk_grid_new ();
#line 110 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp14_, 2);
#line 110 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp14_, 2);
#line 110 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp14_, TRUE);
#line 110 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp14_, TRUE);
#line 110 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp14_, TRUE);
#line 110 "../src/sudoku-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
#line 110 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp14_);
#line 110 "../src/sudoku-view.vala"
	grid = _tmp14_;
#line 118 "../src/sudoku-view.vala"
	_tmp15_ = grid;
#line 118 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp15_, "board");
#line 119 "../src/sudoku-view.vala"
	_tmp16_ = overlay;
#line 119 "../src/sudoku-view.vala"
	_tmp17_ = grid;
#line 119 "../src/sudoku-view.vala"
	gtk_overlay_set_child (_tmp16_, (GtkWidget*) _tmp17_);
#line 121 "../src/sudoku-view.vala"
	_tmp18_ = sudoku_game_get_board (game);
#line 121 "../src/sudoku-view.vala"
	_tmp19_ = _tmp18_;
#line 121 "../src/sudoku-view.vala"
	_tmp20_ = sudoku_board_get_block_rows (_tmp19_);
#line 121 "../src/sudoku-view.vala"
	_tmp21_ = _tmp20_;
#line 121 "../src/sudoku-view.vala"
	_tmp22_ = sudoku_game_get_board (game);
#line 121 "../src/sudoku-view.vala"
	_tmp23_ = _tmp22_;
#line 121 "../src/sudoku-view.vala"
	_tmp24_ = sudoku_board_get_block_cols (_tmp23_);
#line 121 "../src/sudoku-view.vala"
	_tmp25_ = _tmp24_;
#line 121 "../src/sudoku-view.vala"
	_tmp26_ = g_new0 (GtkGrid*, (_tmp21_ * _tmp25_) + 1);
#line 121 "../src/sudoku-view.vala"
	blocks = _tmp26_;
#line 121 "../src/sudoku-view.vala"
	blocks_length1 = _tmp21_;
#line 121 "../src/sudoku-view.vala"
	blocks_length2 = _tmp25_;
#line 711 "sudoku-view.c"
	{
		gint block_row = 0;
#line 122 "../src/sudoku-view.vala"
		block_row = 0;
#line 716 "sudoku-view.c"
		{
			gboolean _tmp27_ = FALSE;
#line 122 "../src/sudoku-view.vala"
			_tmp27_ = TRUE;
#line 122 "../src/sudoku-view.vala"
			while (TRUE) {
#line 723 "sudoku-view.c"
				SudokuBoard* _tmp29_;
				SudokuBoard* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
#line 122 "../src/sudoku-view.vala"
				if (!_tmp27_) {
#line 730 "sudoku-view.c"
					gint _tmp28_;
#line 122 "../src/sudoku-view.vala"
					_tmp28_ = block_row;
#line 122 "../src/sudoku-view.vala"
					block_row = _tmp28_ + 1;
#line 736 "sudoku-view.c"
				}
#line 122 "../src/sudoku-view.vala"
				_tmp27_ = FALSE;
#line 122 "../src/sudoku-view.vala"
				_tmp29_ = sudoku_game_get_board (game);
#line 122 "../src/sudoku-view.vala"
				_tmp30_ = _tmp29_;
#line 122 "../src/sudoku-view.vala"
				_tmp31_ = sudoku_board_get_block_rows (_tmp30_);
#line 122 "../src/sudoku-view.vala"
				_tmp32_ = _tmp31_;
#line 122 "../src/sudoku-view.vala"
				if (!(block_row < _tmp32_)) {
#line 122 "../src/sudoku-view.vala"
					break;
#line 752 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 124 "../src/sudoku-view.vala"
					block_col = 0;
#line 758 "sudoku-view.c"
					{
						gboolean _tmp33_ = FALSE;
#line 124 "../src/sudoku-view.vala"
						_tmp33_ = TRUE;
#line 124 "../src/sudoku-view.vala"
						while (TRUE) {
#line 765 "sudoku-view.c"
							SudokuBoard* _tmp35_;
							SudokuBoard* _tmp36_;
							gint _tmp37_;
							gint _tmp38_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkGrid* _tmp45_;
							GtkGrid* _tmp46_;
							GtkGrid** _tmp47_;
							gint _tmp47__length1;
							gint _tmp47__length2;
							GtkGrid* _tmp48_;
							GtkGrid* _tmp49_;
#line 124 "../src/sudoku-view.vala"
							if (!_tmp33_) {
#line 786 "sudoku-view.c"
								gint _tmp34_;
#line 124 "../src/sudoku-view.vala"
								_tmp34_ = block_col;
#line 124 "../src/sudoku-view.vala"
								block_col = _tmp34_ + 1;
#line 792 "sudoku-view.c"
							}
#line 124 "../src/sudoku-view.vala"
							_tmp33_ = FALSE;
#line 124 "../src/sudoku-view.vala"
							_tmp35_ = sudoku_game_get_board (game);
#line 124 "../src/sudoku-view.vala"
							_tmp36_ = _tmp35_;
#line 124 "../src/sudoku-view.vala"
							_tmp37_ = sudoku_board_get_block_cols (_tmp36_);
#line 124 "../src/sudoku-view.vala"
							_tmp38_ = _tmp37_;
#line 124 "../src/sudoku-view.vala"
							if (!(block_col < _tmp38_)) {
#line 124 "../src/sudoku-view.vala"
								break;
#line 808 "sudoku-view.c"
							}
#line 126 "../src/sudoku-view.vala"
							_tmp39_ = (GtkGrid*) gtk_grid_new ();
#line 126 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp39_);
#line 126 "../src/sudoku-view.vala"
							block_grid = _tmp39_;
#line 127 "../src/sudoku-view.vala"
							_tmp40_ = block_grid;
#line 127 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp40_, 1);
#line 128 "../src/sudoku-view.vala"
							_tmp41_ = block_grid;
#line 128 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp41_, 1);
#line 129 "../src/sudoku-view.vala"
							_tmp42_ = block_grid;
#line 129 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp42_, TRUE);
#line 130 "../src/sudoku-view.vala"
							_tmp43_ = block_grid;
#line 130 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp43_, TRUE);
#line 131 "../src/sudoku-view.vala"
							_tmp44_ = block_grid;
#line 131 "../src/sudoku-view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp44_, "block");
#line 132 "../src/sudoku-view.vala"
							_tmp45_ = grid;
#line 132 "../src/sudoku-view.vala"
							_tmp46_ = block_grid;
#line 132 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, block_col, block_row, 1, 1);
#line 134 "../src/sudoku-view.vala"
							_tmp47_ = blocks;
#line 134 "../src/sudoku-view.vala"
							_tmp47__length1 = blocks_length1;
#line 134 "../src/sudoku-view.vala"
							_tmp47__length2 = blocks_length2;
#line 134 "../src/sudoku-view.vala"
							_tmp48_ = block_grid;
#line 134 "../src/sudoku-view.vala"
							_tmp49_ = _g_object_ref0 (_tmp48_);
#line 134 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp47_[(block_row * _tmp47__length2) + block_col]);
#line 134 "../src/sudoku-view.vala"
							_tmp47_[(block_row * _tmp47__length2) + block_col] = _tmp49_;
#line 124 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 858 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 138 "../src/sudoku-view.vala"
	_tmp50_ = sudoku_game_get_board (game);
#line 138 "../src/sudoku-view.vala"
	_tmp51_ = _tmp50_;
#line 138 "../src/sudoku-view.vala"
	_tmp52_ = sudoku_board_get_rows (_tmp51_);
#line 138 "../src/sudoku-view.vala"
	_tmp53_ = _tmp52_;
#line 138 "../src/sudoku-view.vala"
	_tmp54_ = sudoku_game_get_board (game);
#line 138 "../src/sudoku-view.vala"
	_tmp55_ = _tmp54_;
#line 138 "../src/sudoku-view.vala"
	_tmp56_ = sudoku_board_get_cols (_tmp55_);
#line 138 "../src/sudoku-view.vala"
	_tmp57_ = _tmp56_;
#line 138 "../src/sudoku-view.vala"
	_tmp58_ = g_new0 (SudokuCell*, (_tmp53_ * _tmp57_) + 1);
#line 138 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 138 "../src/sudoku-view.vala"
	self->priv->cells = _tmp58_;
#line 138 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp53_;
#line 138 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp57_;
#line 891 "sudoku-view.c"
	{
		gint row = 0;
#line 139 "../src/sudoku-view.vala"
		row = 0;
#line 896 "sudoku-view.c"
		{
			gboolean _tmp59_ = FALSE;
#line 139 "../src/sudoku-view.vala"
			_tmp59_ = TRUE;
#line 139 "../src/sudoku-view.vala"
			while (TRUE) {
#line 903 "sudoku-view.c"
				SudokuBoard* _tmp61_;
				SudokuBoard* _tmp62_;
				gint _tmp63_;
				gint _tmp64_;
#line 139 "../src/sudoku-view.vala"
				if (!_tmp59_) {
#line 910 "sudoku-view.c"
					gint _tmp60_;
#line 139 "../src/sudoku-view.vala"
					_tmp60_ = row;
#line 139 "../src/sudoku-view.vala"
					row = _tmp60_ + 1;
#line 916 "sudoku-view.c"
				}
#line 139 "../src/sudoku-view.vala"
				_tmp59_ = FALSE;
#line 139 "../src/sudoku-view.vala"
				_tmp61_ = sudoku_game_get_board (game);
#line 139 "../src/sudoku-view.vala"
				_tmp62_ = _tmp61_;
#line 139 "../src/sudoku-view.vala"
				_tmp63_ = sudoku_board_get_rows (_tmp62_);
#line 139 "../src/sudoku-view.vala"
				_tmp64_ = _tmp63_;
#line 139 "../src/sudoku-view.vala"
				if (!(row < _tmp64_)) {
#line 139 "../src/sudoku-view.vala"
					break;
#line 932 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 141 "../src/sudoku-view.vala"
					col = 0;
#line 938 "sudoku-view.c"
					{
						gboolean _tmp65_ = FALSE;
#line 141 "../src/sudoku-view.vala"
						_tmp65_ = TRUE;
#line 141 "../src/sudoku-view.vala"
						while (TRUE) {
#line 945 "sudoku-view.c"
							SudokuBoard* _tmp67_;
							SudokuBoard* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							SudokuCell* cell = NULL;
							SudokuCell* _tmp71_;
							SudokuCell* _tmp72_;
							GtkGrid** _tmp73_;
							gint _tmp73__length1;
							gint _tmp73__length2;
							SudokuBoard* _tmp74_;
							SudokuBoard* _tmp75_;
							gint _tmp76_;
							gint _tmp77_;
							SudokuBoard* _tmp78_;
							SudokuBoard* _tmp79_;
							gint _tmp80_;
							gint _tmp81_;
							GtkGrid* _tmp82_;
							SudokuCell* _tmp83_;
							SudokuBoard* _tmp84_;
							SudokuBoard* _tmp85_;
							gint _tmp86_;
							gint _tmp87_;
							SudokuBoard* _tmp88_;
							SudokuBoard* _tmp89_;
							gint _tmp90_;
							gint _tmp91_;
							SudokuCell** _tmp92_;
							gint _tmp92__length1;
							gint _tmp92__length2;
							SudokuCell* _tmp93_;
							SudokuCell* _tmp94_;
#line 141 "../src/sudoku-view.vala"
							if (!_tmp65_) {
#line 981 "sudoku-view.c"
								gint _tmp66_;
#line 141 "../src/sudoku-view.vala"
								_tmp66_ = col;
#line 141 "../src/sudoku-view.vala"
								col = _tmp66_ + 1;
#line 987 "sudoku-view.c"
							}
#line 141 "../src/sudoku-view.vala"
							_tmp65_ = FALSE;
#line 141 "../src/sudoku-view.vala"
							_tmp67_ = sudoku_game_get_board (game);
#line 141 "../src/sudoku-view.vala"
							_tmp68_ = _tmp67_;
#line 141 "../src/sudoku-view.vala"
							_tmp69_ = sudoku_board_get_cols (_tmp68_);
#line 141 "../src/sudoku-view.vala"
							_tmp70_ = _tmp69_;
#line 141 "../src/sudoku-view.vala"
							if (!(col < _tmp70_)) {
#line 141 "../src/sudoku-view.vala"
								break;
#line 1003 "sudoku-view.c"
							}
#line 143 "../src/sudoku-view.vala"
							_tmp71_ = sudoku_cell_new (row, col, game, self);
#line 143 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp71_);
#line 143 "../src/sudoku-view.vala"
							cell = _tmp71_;
#line 144 "../src/sudoku-view.vala"
							_tmp72_ = cell;
#line 144 "../src/sudoku-view.vala"
							sudoku_cell_get_visible_earmarks (_tmp72_);
#line 145 "../src/sudoku-view.vala"
							_tmp73_ = blocks;
#line 145 "../src/sudoku-view.vala"
							_tmp73__length1 = blocks_length1;
#line 145 "../src/sudoku-view.vala"
							_tmp73__length2 = blocks_length2;
#line 145 "../src/sudoku-view.vala"
							_tmp74_ = sudoku_game_get_board (game);
#line 145 "../src/sudoku-view.vala"
							_tmp75_ = _tmp74_;
#line 145 "../src/sudoku-view.vala"
							_tmp76_ = sudoku_board_get_block_rows (_tmp75_);
#line 145 "../src/sudoku-view.vala"
							_tmp77_ = _tmp76_;
#line 145 "../src/sudoku-view.vala"
							_tmp78_ = sudoku_game_get_board (game);
#line 145 "../src/sudoku-view.vala"
							_tmp79_ = _tmp78_;
#line 145 "../src/sudoku-view.vala"
							_tmp80_ = sudoku_board_get_block_cols (_tmp79_);
#line 145 "../src/sudoku-view.vala"
							_tmp81_ = _tmp80_;
#line 145 "../src/sudoku-view.vala"
							_tmp82_ = _tmp73_[((row / _tmp77_) * _tmp73__length2) + (col / _tmp81_)];
#line 145 "../src/sudoku-view.vala"
							_tmp83_ = cell;
#line 145 "../src/sudoku-view.vala"
							_tmp84_ = sudoku_game_get_board (game);
#line 145 "../src/sudoku-view.vala"
							_tmp85_ = _tmp84_;
#line 145 "../src/sudoku-view.vala"
							_tmp86_ = sudoku_board_get_block_cols (_tmp85_);
#line 145 "../src/sudoku-view.vala"
							_tmp87_ = _tmp86_;
#line 145 "../src/sudoku-view.vala"
							_tmp88_ = sudoku_game_get_board (game);
#line 145 "../src/sudoku-view.vala"
							_tmp89_ = _tmp88_;
#line 145 "../src/sudoku-view.vala"
							_tmp90_ = sudoku_board_get_block_rows (_tmp89_);
#line 145 "../src/sudoku-view.vala"
							_tmp91_ = _tmp90_;
#line 145 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp82_, (GtkWidget*) _tmp83_, col % _tmp87_, row % _tmp91_, 1, 1);
#line 146 "../src/sudoku-view.vala"
							_tmp92_ = self->priv->cells;
#line 146 "../src/sudoku-view.vala"
							_tmp92__length1 = self->priv->cells_length1;
#line 146 "../src/sudoku-view.vala"
							_tmp92__length2 = self->priv->cells_length2;
#line 146 "../src/sudoku-view.vala"
							_tmp93_ = cell;
#line 146 "../src/sudoku-view.vala"
							_tmp94_ = _g_object_ref0 (_tmp93_);
#line 146 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp92_[(row * _tmp92__length2) + col]);
#line 146 "../src/sudoku-view.vala"
							_tmp92_[(row * _tmp92__length2) + col] = _tmp94_;
#line 141 "../src/sudoku-view.vala"
							_g_object_unref0 (cell);
#line 1075 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 150 "../src/sudoku-view.vala"
	_tmp95_ = self->priv->game;
#line 150 "../src/sudoku-view.vala"
	_tmp96_ = sudoku_game_get_board (_tmp95_);
#line 150 "../src/sudoku-view.vala"
	_tmp97_ = _tmp96_;
#line 150 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp97_, "value-changed", (GCallback) _sudoku_view_value_changed_cb_sudoku_board_value_changed, self, 0);
#line 151 "../src/sudoku-view.vala"
	_tmp98_ = self->priv->game;
#line 151 "../src/sudoku-view.vala"
	_tmp99_ = sudoku_game_get_board (_tmp98_);
#line 151 "../src/sudoku-view.vala"
	_tmp100_ = _tmp99_;
#line 151 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp100_, "earmark-changed", (GCallback) _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed, self, 0);
#line 152 "../src/sudoku-view.vala"
	g_signal_connect_object (self, "selection-changed", (GCallback) _sudoku_view_selection_changed_cb_sudoku_view_selection_changed, self, 0);
#line 154 "../src/sudoku-view.vala"
	_tmp103_ = sudoku_view_get_show_possibilities (self);
#line 154 "../src/sudoku-view.vala"
	_tmp104_ = _tmp103_;
#line 154 "../src/sudoku-view.vala"
	if (_tmp104_) {
#line 1106 "sudoku-view.c"
		GameMode _tmp105_;
		GameMode _tmp106_;
#line 154 "../src/sudoku-view.vala"
		_tmp105_ = sudoku_game_get_mode (game);
#line 154 "../src/sudoku-view.vala"
		_tmp106_ = _tmp105_;
#line 154 "../src/sudoku-view.vala"
		_tmp102_ = _tmp106_ != GAME_MODE_CREATE;
#line 1115 "sudoku-view.c"
	} else {
#line 154 "../src/sudoku-view.vala"
		_tmp102_ = FALSE;
#line 1119 "sudoku-view.c"
	}
#line 154 "../src/sudoku-view.vala"
	if (_tmp102_) {
#line 1123 "sudoku-view.c"
		SudokuBoard* _tmp107_;
		SudokuBoard* _tmp108_;
		gdouble _tmp109_;
		gdouble _tmp110_;
#line 154 "../src/sudoku-view.vala"
		_tmp107_ = sudoku_game_get_board (game);
#line 154 "../src/sudoku-view.vala"
		_tmp108_ = _tmp107_;
#line 154 "../src/sudoku-view.vala"
		_tmp109_ = sudoku_board_get_previous_played_time (_tmp108_);
#line 154 "../src/sudoku-view.vala"
		_tmp110_ = _tmp109_;
#line 154 "../src/sudoku-view.vala"
		_tmp101_ = _tmp110_ == 0.0;
#line 1138 "sudoku-view.c"
	} else {
#line 154 "../src/sudoku-view.vala"
		_tmp101_ = FALSE;
#line 1142 "sudoku-view.c"
	}
#line 154 "../src/sudoku-view.vala"
	if (_tmp101_) {
#line 155 "../src/sudoku-view.vala"
		sudoku_game_enable_all_earmark_possibilities (game);
#line 1148 "sudoku-view.c"
	}
#line 157 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 48 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 48 "../src/sudoku-view.vala"
	_g_object_unref0 (grid);
#line 48 "../src/sudoku-view.vala"
	_g_object_unref0 (overlay);
#line 48 "../src/sudoku-view.vala"
	return self;
#line 1160 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (SudokuGame* game,
                 GSettings* settings)
{
#line 48 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game, settings);
#line 1169 "sudoku-view.c"
}

static void
sudoku_view_selection_changed_cb (SudokuView* self,
                                  gint old_row,
                                  gint old_col,
                                  gint new_row,
                                  gint new_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
#line 228 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, old_row, old_col, FALSE);
#line 231 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, new_row, new_col, TRUE);
#line 232 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 232 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 232 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 232 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(old_row * _tmp0__length2) + old_col];
#line 232 "../src/sudoku-view.vala"
	sudoku_cell_dismiss_popover (_tmp1_);
#line 1199 "sudoku-view.c"
}

static void
sudoku_view_value_changed_cb (SudokuView* self,
                              gint row,
                              gint col,
                              gint old_val,
                              gint new_val)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	SudokuCell* _tmp2_;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
#line 235 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 237 "../src/sudoku-view.vala"
	action = sudoku_game_get_current_stack_action (_tmp0_);
#line 239 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->cells;
#line 239 "../src/sudoku-view.vala"
	_tmp1__length1 = self->priv->cells_length1;
#line 239 "../src/sudoku-view.vala"
	_tmp1__length2 = self->priv->cells_length2;
#line 239 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 239 "../src/sudoku-view.vala"
	sudoku_cell_update_value (_tmp2_);
#line 240 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 242 "../src/sudoku-view.vala"
	if (stack_action_is_single_value_change (action)) {
#line 1237 "sudoku-view.c"
		SudokuCell** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		SudokuCell* _tmp4_;
#line 243 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->cells;
#line 243 "../src/sudoku-view.vala"
		_tmp3__length1 = self->priv->cells_length1;
#line 243 "../src/sudoku-view.vala"
		_tmp3__length2 = self->priv->cells_length2;
#line 243 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
#line 243 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
#line 1252 "sudoku-view.c"
	}
#line 246 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->_selected_row;
#line 246 "../src/sudoku-view.vala"
	if (row == _tmp6_) {
#line 1258 "sudoku-view.c"
		gint _tmp7_;
#line 246 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->_selected_col;
#line 246 "../src/sudoku-view.vala"
		_tmp5_ = col == _tmp7_;
#line 1264 "sudoku-view.c"
	} else {
#line 246 "../src/sudoku-view.vala"
		_tmp5_ = FALSE;
#line 1268 "sudoku-view.c"
	}
#line 246 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 248 "../src/sudoku-view.vala"
		sudoku_view_set_selected_value_highlighter (self, old_val, FALSE);
#line 249 "../src/sudoku-view.vala"
		sudoku_view_set_selected_value_highlighter (self, new_val, TRUE);
#line 1276 "sudoku-view.c"
	} else {
#line 253 "../src/sudoku-view.vala"
		sudoku_view_set_unselected_value_highlighter (self, row, col, old_val, FALSE);
#line 254 "../src/sudoku-view.vala"
		sudoku_view_set_unselected_value_highlighter (self, row, col, new_val, TRUE);
#line 1282 "sudoku-view.c"
	}
}

static void
sudoku_view_earmark_changed_cb (SudokuView* self,
                                gint row,
                                gint col,
                                gint num,
                                gboolean enabled)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	SudokuCell* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 258 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 260 "../src/sudoku-view.vala"
	action = sudoku_game_get_current_stack_action (_tmp0_);
#line 261 "../src/sudoku-view.vala"
	if (stack_action_is_single_earmarks_change (action)) {
#line 1310 "sudoku-view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
#line 262 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 262 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 262 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 262 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 262 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 1325 "sudoku-view.c"
	}
#line 264 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->cells;
#line 264 "../src/sudoku-view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 264 "../src/sudoku-view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 264 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
#line 264 "../src/sudoku-view.vala"
	sudoku_cell_get_visible_earmark (_tmp4_, num);
#line 265 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_view_get_show_warnings (self);
#line 265 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 265 "../src/sudoku-view.vala"
	if (_tmp7_) {
#line 265 "../src/sudoku-view.vala"
		_tmp5_ = enabled;
#line 1345 "sudoku-view.c"
	} else {
#line 265 "../src/sudoku-view.vala"
		_tmp5_ = FALSE;
#line 1349 "sudoku-view.c"
	}
#line 265 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 1353 "sudoku-view.c"
		SudokuCell** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		SudokuCell* _tmp9_;
#line 266 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->cells;
#line 266 "../src/sudoku-view.vala"
		_tmp8__length1 = self->priv->cells_length1;
#line 266 "../src/sudoku-view.vala"
		_tmp8__length2 = self->priv->cells_length2;
#line 266 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_[(row * _tmp8__length2) + col];
#line 266 "../src/sudoku-view.vala"
		sudoku_cell_check_earmark_warnings (_tmp9_, num);
#line 1368 "sudoku-view.c"
	}
}

void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint _tmp6_;
	SudokuCell* _tmp7_;
	gint old_row = 0;
	gint _tmp8_;
	gint old_col = 0;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	SudokuCell** _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gint _tmp13_;
	gint _tmp14_;
	SudokuCell* _tmp15_;
#line 269 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 271 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 271 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 271 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(cell_row * _tmp0__length2) + cell_col];
#line 271 "../src/sudoku-view.vala"
	_tmp2_ = sudoku_cell_get_selected (_tmp1_);
#line 271 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 271 "../src/sudoku-view.vala"
	if (_tmp3_ == TRUE) {
#line 272 "../src/sudoku-view.vala"
		return;
#line 1419 "sudoku-view.c"
	}
#line 274 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->cells;
#line 274 "../src/sudoku-view.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 274 "../src/sudoku-view.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 274 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->_selected_row;
#line 274 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->_selected_col;
#line 274 "../src/sudoku-view.vala"
	_tmp7_ = _tmp4_[(_tmp5_ * _tmp4__length2) + _tmp6_];
#line 274 "../src/sudoku-view.vala"
	sudoku_cell_set_selected (_tmp7_, FALSE);
#line 276 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->_selected_row;
#line 276 "../src/sudoku-view.vala"
	old_row = _tmp8_;
#line 277 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->_selected_col;
#line 277 "../src/sudoku-view.vala"
	old_col = _tmp9_;
#line 279 "../src/sudoku-view.vala"
	sudoku_view_set_selected_row (self, cell_row);
#line 280 "../src/sudoku-view.vala"
	sudoku_view_set_selected_col (self, cell_col);
#line 282 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->_selected_row;
#line 282 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->_selected_col;
#line 282 "../src/sudoku-view.vala"
	g_signal_emit (self, sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL], 0, old_row, old_col, _tmp10_, _tmp11_);
#line 284 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->cells;
#line 284 "../src/sudoku-view.vala"
	_tmp12__length1 = self->priv->cells_length1;
#line 284 "../src/sudoku-view.vala"
	_tmp12__length2 = self->priv->cells_length2;
#line 284 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_row;
#line 284 "../src/sudoku-view.vala"
	_tmp14_ = self->priv->_selected_col;
#line 284 "../src/sudoku-view.vala"
	_tmp15_ = _tmp12_[(_tmp13_ * _tmp12__length2) + _tmp14_];
#line 284 "../src/sudoku-view.vala"
	sudoku_cell_set_selected (_tmp15_, TRUE);
#line 1467 "sudoku-view.c"
}

static void
sudoku_view_set_cell_highlighter (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
#line 287 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_highlighter (self);
#line 289 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 289 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 290 "../src/sudoku-view.vala"
		return;
#line 1494 "sudoku-view.c"
	}
#line 292 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->cells;
#line 292 "../src/sudoku-view.vala"
	_tmp2__length1 = self->priv->cells_length1;
#line 292 "../src/sudoku-view.vala"
	_tmp2__length2 = self->priv->cells_length2;
#line 292 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 292 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 292 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 1508 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 294 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1513 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 294 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 294 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1520 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				SudokuBoard* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 294 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 1528 "sudoku-view.c"
					gint _tmp6_;
#line 294 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 294 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 1534 "sudoku-view.c"
				}
#line 294 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 294 "../src/sudoku-view.vala"
				_tmp7_ = self->priv->game;
#line 294 "../src/sudoku-view.vala"
				_tmp8_ = sudoku_game_get_board (_tmp7_);
#line 294 "../src/sudoku-view.vala"
				_tmp9_ = _tmp8_;
#line 294 "../src/sudoku-view.vala"
				_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 294 "../src/sudoku-view.vala"
				_tmp11_ = _tmp10_;
#line 294 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp11_)) {
#line 294 "../src/sudoku-view.vala"
					break;
#line 1552 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 296 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1558 "sudoku-view.c"
					{
						gboolean _tmp12_ = FALSE;
#line 296 "../src/sudoku-view.vala"
						_tmp12_ = TRUE;
#line 296 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1565 "sudoku-view.c"
							SudokuGame* _tmp14_;
							SudokuBoard* _tmp15_;
							SudokuBoard* _tmp16_;
							gint _tmp17_;
							gint _tmp18_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp19_;
							gint _tmp19__length1;
							gint _tmp19__length2;
							SudokuCell* _tmp20_;
							SudokuCell* _tmp21_;
							SudokuCell* _tmp22_;
							SudokuCell* _tmp23_;
							gboolean _tmp24_ = FALSE;
							SudokuCell* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gboolean _tmp42_ = FALSE;
							SudokuCell* _tmp43_;
							gboolean _tmp44_;
							gboolean _tmp45_;
#line 296 "../src/sudoku-view.vala"
							if (!_tmp12_) {
#line 1589 "sudoku-view.c"
								gint _tmp13_;
#line 296 "../src/sudoku-view.vala"
								_tmp13_ = row_tmp;
#line 296 "../src/sudoku-view.vala"
								row_tmp = _tmp13_ + 1;
#line 1595 "sudoku-view.c"
							}
#line 296 "../src/sudoku-view.vala"
							_tmp12_ = FALSE;
#line 296 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->game;
#line 296 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 296 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 296 "../src/sudoku-view.vala"
							_tmp17_ = sudoku_board_get_rows (_tmp16_);
#line 296 "../src/sudoku-view.vala"
							_tmp18_ = _tmp17_;
#line 296 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp18_)) {
#line 296 "../src/sudoku-view.vala"
								break;
#line 1613 "sudoku-view.c"
							}
#line 298 "../src/sudoku-view.vala"
							_tmp19_ = self->priv->cells;
#line 298 "../src/sudoku-view.vala"
							_tmp19__length1 = self->priv->cells_length1;
#line 298 "../src/sudoku-view.vala"
							_tmp19__length2 = self->priv->cells_length2;
#line 298 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_[(row_tmp * _tmp19__length2) + col_tmp];
#line 298 "../src/sudoku-view.vala"
							_tmp21_ = _g_object_ref0 (_tmp20_);
#line 298 "../src/sudoku-view.vala"
							cell_tmp = _tmp21_;
#line 300 "../src/sudoku-view.vala"
							_tmp22_ = cell;
#line 300 "../src/sudoku-view.vala"
							_tmp23_ = cell_tmp;
#line 300 "../src/sudoku-view.vala"
							if (_tmp22_ == _tmp23_) {
#line 301 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 301 "../src/sudoku-view.vala"
								continue;
#line 1637 "sudoku-view.c"
							}
#line 303 "../src/sudoku-view.vala"
							_tmp25_ = cell;
#line 303 "../src/sudoku-view.vala"
							_tmp26_ = sudoku_cell_get_value (_tmp25_);
#line 303 "../src/sudoku-view.vala"
							_tmp27_ = _tmp26_;
#line 303 "../src/sudoku-view.vala"
							if (_tmp27_ > 0) {
#line 303 "../src/sudoku-view.vala"
								_tmp24_ = self->highlight_numbers;
#line 1649 "sudoku-view.c"
							} else {
#line 303 "../src/sudoku-view.vala"
								_tmp24_ = FALSE;
#line 1653 "sudoku-view.c"
							}
#line 303 "../src/sudoku-view.vala"
							if (_tmp24_) {
#line 1657 "sudoku-view.c"
								SudokuCell* _tmp28_;
								gint _tmp29_;
								gint _tmp30_;
								SudokuCell* _tmp31_;
								gint _tmp32_;
								gint _tmp33_;
#line 305 "../src/sudoku-view.vala"
								_tmp28_ = cell;
#line 305 "../src/sudoku-view.vala"
								_tmp29_ = sudoku_cell_get_value (_tmp28_);
#line 305 "../src/sudoku-view.vala"
								_tmp30_ = _tmp29_;
#line 305 "../src/sudoku-view.vala"
								_tmp31_ = cell_tmp;
#line 305 "../src/sudoku-view.vala"
								_tmp32_ = sudoku_cell_get_value (_tmp31_);
#line 305 "../src/sudoku-view.vala"
								_tmp33_ = _tmp32_;
#line 305 "../src/sudoku-view.vala"
								if (_tmp30_ == _tmp33_) {
#line 1678 "sudoku-view.c"
									SudokuCell* _tmp34_;
#line 306 "../src/sudoku-view.vala"
									_tmp34_ = cell_tmp;
#line 306 "../src/sudoku-view.vala"
									sudoku_cell_set_highlight_number (_tmp34_, enabled);
#line 1684 "sudoku-view.c"
								} else {
									SudokuCell* _tmp35_;
									gint _tmp36_;
									gint _tmp37_;
#line 307 "../src/sudoku-view.vala"
									_tmp35_ = cell_tmp;
#line 307 "../src/sudoku-view.vala"
									_tmp36_ = sudoku_cell_get_value (_tmp35_);
#line 307 "../src/sudoku-view.vala"
									_tmp37_ = _tmp36_;
#line 307 "../src/sudoku-view.vala"
									if (_tmp37_ == 0) {
#line 1697 "sudoku-view.c"
										SudokuCell* _tmp38_;
										SudokuCell* _tmp39_;
										gint _tmp40_;
										gint _tmp41_;
#line 308 "../src/sudoku-view.vala"
										_tmp38_ = cell_tmp;
#line 308 "../src/sudoku-view.vala"
										_tmp39_ = cell;
#line 308 "../src/sudoku-view.vala"
										_tmp40_ = sudoku_cell_get_value (_tmp39_);
#line 308 "../src/sudoku-view.vala"
										_tmp41_ = _tmp40_;
#line 308 "../src/sudoku-view.vala"
										sudoku_cell_set_earmark_highlight (_tmp38_, _tmp41_, enabled);
#line 1712 "sudoku-view.c"
									}
								}
							}
#line 311 "../src/sudoku-view.vala"
							_tmp43_ = cell_tmp;
#line 311 "../src/sudoku-view.vala"
							_tmp44_ = sudoku_cell_get_is_fixed (_tmp43_);
#line 311 "../src/sudoku-view.vala"
							_tmp45_ = _tmp44_;
#line 311 "../src/sudoku-view.vala"
							if (!_tmp45_) {
#line 1724 "sudoku-view.c"
								gboolean _tmp46_ = FALSE;
								gboolean _tmp47_ = FALSE;
#line 312 "../src/sudoku-view.vala"
								if (self->highlight_row_column) {
#line 1729 "sudoku-view.c"
									gboolean _tmp48_ = FALSE;
#line 312 "../src/sudoku-view.vala"
									if (row_tmp == row) {
#line 312 "../src/sudoku-view.vala"
										_tmp48_ = TRUE;
#line 1735 "sudoku-view.c"
									} else {
#line 312 "../src/sudoku-view.vala"
										_tmp48_ = col_tmp == col;
#line 1739 "sudoku-view.c"
									}
#line 312 "../src/sudoku-view.vala"
									_tmp47_ = _tmp48_;
#line 1743 "sudoku-view.c"
								} else {
#line 312 "../src/sudoku-view.vala"
									_tmp47_ = FALSE;
#line 1747 "sudoku-view.c"
								}
#line 312 "../src/sudoku-view.vala"
								if (_tmp47_) {
#line 312 "../src/sudoku-view.vala"
									_tmp46_ = TRUE;
#line 1753 "sudoku-view.c"
								} else {
									gboolean _tmp49_ = FALSE;
									gboolean _tmp50_ = FALSE;
#line 313 "../src/sudoku-view.vala"
									if (self->highlight_block) {
#line 1759 "sudoku-view.c"
										SudokuGame* _tmp51_;
										SudokuBoard* _tmp52_;
										SudokuBoard* _tmp53_;
										gint _tmp54_;
										gint _tmp55_;
										SudokuGame* _tmp56_;
										SudokuBoard* _tmp57_;
										SudokuBoard* _tmp58_;
										gint _tmp59_;
										gint _tmp60_;
#line 314 "../src/sudoku-view.vala"
										_tmp51_ = self->priv->game;
#line 314 "../src/sudoku-view.vala"
										_tmp52_ = sudoku_game_get_board (_tmp51_);
#line 314 "../src/sudoku-view.vala"
										_tmp53_ = _tmp52_;
#line 314 "../src/sudoku-view.vala"
										_tmp54_ = sudoku_board_get_block_cols (_tmp53_);
#line 314 "../src/sudoku-view.vala"
										_tmp55_ = _tmp54_;
#line 314 "../src/sudoku-view.vala"
										_tmp56_ = self->priv->game;
#line 314 "../src/sudoku-view.vala"
										_tmp57_ = sudoku_game_get_board (_tmp56_);
#line 314 "../src/sudoku-view.vala"
										_tmp58_ = _tmp57_;
#line 314 "../src/sudoku-view.vala"
										_tmp59_ = sudoku_board_get_block_cols (_tmp58_);
#line 314 "../src/sudoku-view.vala"
										_tmp60_ = _tmp59_;
#line 314 "../src/sudoku-view.vala"
										_tmp50_ = (row_tmp / _tmp55_) == (row / _tmp60_);
#line 1792 "sudoku-view.c"
									} else {
#line 313 "../src/sudoku-view.vala"
										_tmp50_ = FALSE;
#line 1796 "sudoku-view.c"
									}
#line 313 "../src/sudoku-view.vala"
									if (_tmp50_) {
#line 1800 "sudoku-view.c"
										SudokuGame* _tmp61_;
										SudokuBoard* _tmp62_;
										SudokuBoard* _tmp63_;
										gint _tmp64_;
										gint _tmp65_;
										SudokuGame* _tmp66_;
										SudokuBoard* _tmp67_;
										SudokuBoard* _tmp68_;
										gint _tmp69_;
										gint _tmp70_;
#line 315 "../src/sudoku-view.vala"
										_tmp61_ = self->priv->game;
#line 315 "../src/sudoku-view.vala"
										_tmp62_ = sudoku_game_get_board (_tmp61_);
#line 315 "../src/sudoku-view.vala"
										_tmp63_ = _tmp62_;
#line 315 "../src/sudoku-view.vala"
										_tmp64_ = sudoku_board_get_block_rows (_tmp63_);
#line 315 "../src/sudoku-view.vala"
										_tmp65_ = _tmp64_;
#line 315 "../src/sudoku-view.vala"
										_tmp66_ = self->priv->game;
#line 315 "../src/sudoku-view.vala"
										_tmp67_ = sudoku_game_get_board (_tmp66_);
#line 315 "../src/sudoku-view.vala"
										_tmp68_ = _tmp67_;
#line 315 "../src/sudoku-view.vala"
										_tmp69_ = sudoku_board_get_block_rows (_tmp68_);
#line 315 "../src/sudoku-view.vala"
										_tmp70_ = _tmp69_;
#line 315 "../src/sudoku-view.vala"
										_tmp49_ = (col_tmp / _tmp65_) == (col / _tmp70_);
#line 1833 "sudoku-view.c"
									} else {
#line 313 "../src/sudoku-view.vala"
										_tmp49_ = FALSE;
#line 1837 "sudoku-view.c"
									}
#line 313 "../src/sudoku-view.vala"
									_tmp46_ = _tmp49_;
#line 1841 "sudoku-view.c"
								}
#line 312 "../src/sudoku-view.vala"
								_tmp42_ = _tmp46_;
#line 1845 "sudoku-view.c"
							} else {
#line 311 "../src/sudoku-view.vala"
								_tmp42_ = FALSE;
#line 1849 "sudoku-view.c"
							}
#line 311 "../src/sudoku-view.vala"
							if (_tmp42_) {
#line 1853 "sudoku-view.c"
								SudokuCell* _tmp71_;
#line 317 "../src/sudoku-view.vala"
								_tmp71_ = cell_tmp;
#line 317 "../src/sudoku-view.vala"
								sudoku_cell_set_highlight_coord (_tmp71_, enabled);
#line 1859 "sudoku-view.c"
							}
#line 296 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 1863 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 287 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 1872 "sudoku-view.c"
}

static void
sudoku_view_set_selected_value_highlighter (SudokuView* self,
                                            gint val,
                                            gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint _tmp6_;
	SudokuCell* _tmp7_;
	SudokuCell* _tmp8_;
#line 323 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 325 "../src/sudoku-view.vala"
	_tmp2_ = sudoku_view_get_highlighter (self);
#line 325 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 325 "../src/sudoku-view.vala"
	if (!_tmp3_) {
#line 325 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 1902 "sudoku-view.c"
	} else {
#line 325 "../src/sudoku-view.vala"
		_tmp1_ = val == 0;
#line 1906 "sudoku-view.c"
	}
#line 325 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 325 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 1912 "sudoku-view.c"
	} else {
#line 325 "../src/sudoku-view.vala"
		_tmp0_ = !self->highlight_numbers;
#line 1916 "sudoku-view.c"
	}
#line 325 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 326 "../src/sudoku-view.vala"
		return;
#line 1922 "sudoku-view.c"
	}
#line 328 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->cells;
#line 328 "../src/sudoku-view.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 328 "../src/sudoku-view.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 328 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->_selected_row;
#line 328 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->_selected_col;
#line 328 "../src/sudoku-view.vala"
	_tmp7_ = _tmp4_[(_tmp5_ * _tmp4__length2) + _tmp6_];
#line 328 "../src/sudoku-view.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 328 "../src/sudoku-view.vala"
	cell = _tmp8_;
#line 1940 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 330 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1945 "sudoku-view.c"
		{
			gboolean _tmp9_ = FALSE;
#line 330 "../src/sudoku-view.vala"
			_tmp9_ = TRUE;
#line 330 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1952 "sudoku-view.c"
				SudokuGame* _tmp11_;
				SudokuBoard* _tmp12_;
				SudokuBoard* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 330 "../src/sudoku-view.vala"
				if (!_tmp9_) {
#line 1960 "sudoku-view.c"
					gint _tmp10_;
#line 330 "../src/sudoku-view.vala"
					_tmp10_ = col_tmp;
#line 330 "../src/sudoku-view.vala"
					col_tmp = _tmp10_ + 1;
#line 1966 "sudoku-view.c"
				}
#line 330 "../src/sudoku-view.vala"
				_tmp9_ = FALSE;
#line 330 "../src/sudoku-view.vala"
				_tmp11_ = self->priv->game;
#line 330 "../src/sudoku-view.vala"
				_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 330 "../src/sudoku-view.vala"
				_tmp13_ = _tmp12_;
#line 330 "../src/sudoku-view.vala"
				_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 330 "../src/sudoku-view.vala"
				_tmp15_ = _tmp14_;
#line 330 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp15_)) {
#line 330 "../src/sudoku-view.vala"
					break;
#line 1984 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 332 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1990 "sudoku-view.c"
					{
						gboolean _tmp16_ = FALSE;
#line 332 "../src/sudoku-view.vala"
						_tmp16_ = TRUE;
#line 332 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1997 "sudoku-view.c"
							SudokuGame* _tmp18_;
							SudokuBoard* _tmp19_;
							SudokuBoard* _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp23_;
							gint _tmp23__length1;
							gint _tmp23__length2;
							SudokuCell* _tmp24_;
							SudokuCell* _tmp25_;
							SudokuCell* _tmp26_;
							SudokuCell* _tmp27_;
							SudokuCell* _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
#line 332 "../src/sudoku-view.vala"
							if (!_tmp16_) {
#line 2016 "sudoku-view.c"
								gint _tmp17_;
#line 332 "../src/sudoku-view.vala"
								_tmp17_ = row_tmp;
#line 332 "../src/sudoku-view.vala"
								row_tmp = _tmp17_ + 1;
#line 2022 "sudoku-view.c"
							}
#line 332 "../src/sudoku-view.vala"
							_tmp16_ = FALSE;
#line 332 "../src/sudoku-view.vala"
							_tmp18_ = self->priv->game;
#line 332 "../src/sudoku-view.vala"
							_tmp19_ = sudoku_game_get_board (_tmp18_);
#line 332 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_;
#line 332 "../src/sudoku-view.vala"
							_tmp21_ = sudoku_board_get_rows (_tmp20_);
#line 332 "../src/sudoku-view.vala"
							_tmp22_ = _tmp21_;
#line 332 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp22_)) {
#line 332 "../src/sudoku-view.vala"
								break;
#line 2040 "sudoku-view.c"
							}
#line 334 "../src/sudoku-view.vala"
							_tmp23_ = self->priv->cells;
#line 334 "../src/sudoku-view.vala"
							_tmp23__length1 = self->priv->cells_length1;
#line 334 "../src/sudoku-view.vala"
							_tmp23__length2 = self->priv->cells_length2;
#line 334 "../src/sudoku-view.vala"
							_tmp24_ = _tmp23_[(row_tmp * _tmp23__length2) + col_tmp];
#line 334 "../src/sudoku-view.vala"
							_tmp25_ = _g_object_ref0 (_tmp24_);
#line 334 "../src/sudoku-view.vala"
							cell_tmp = _tmp25_;
#line 336 "../src/sudoku-view.vala"
							_tmp26_ = cell;
#line 336 "../src/sudoku-view.vala"
							_tmp27_ = cell_tmp;
#line 336 "../src/sudoku-view.vala"
							if (_tmp26_ == _tmp27_) {
#line 337 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 337 "../src/sudoku-view.vala"
								continue;
#line 2064 "sudoku-view.c"
							}
#line 339 "../src/sudoku-view.vala"
							_tmp28_ = cell_tmp;
#line 339 "../src/sudoku-view.vala"
							_tmp29_ = sudoku_cell_get_value (_tmp28_);
#line 339 "../src/sudoku-view.vala"
							_tmp30_ = _tmp29_;
#line 339 "../src/sudoku-view.vala"
							if (val == _tmp30_) {
#line 2074 "sudoku-view.c"
								SudokuCell* _tmp31_;
#line 340 "../src/sudoku-view.vala"
								_tmp31_ = cell_tmp;
#line 340 "../src/sudoku-view.vala"
								sudoku_cell_set_highlight_number (_tmp31_, enabled);
#line 2080 "sudoku-view.c"
							} else {
								SudokuCell* _tmp32_;
								gint _tmp33_;
								gint _tmp34_;
#line 341 "../src/sudoku-view.vala"
								_tmp32_ = cell_tmp;
#line 341 "../src/sudoku-view.vala"
								_tmp33_ = sudoku_cell_get_value (_tmp32_);
#line 341 "../src/sudoku-view.vala"
								_tmp34_ = _tmp33_;
#line 341 "../src/sudoku-view.vala"
								if (_tmp34_ == 0) {
#line 2093 "sudoku-view.c"
									SudokuCell* _tmp35_;
#line 342 "../src/sudoku-view.vala"
									_tmp35_ = cell_tmp;
#line 342 "../src/sudoku-view.vala"
									sudoku_cell_set_earmark_highlight (_tmp35_, val, enabled);
#line 2099 "sudoku-view.c"
								}
							}
#line 332 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 2104 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 323 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 2113 "sudoku-view.c"
}

static void
sudoku_view_set_unselected_value_highlighter (SudokuView* self,
                                              gint row,
                                              gint col,
                                              gint val,
                                              gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint _tmp6_;
	SudokuCell* _tmp7_;
	SudokuCell* _tmp8_;
	SudokuCell* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	SudokuCell* changed_cell = NULL;
	SudokuCell** _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	SudokuCell* _tmp13_;
	SudokuCell* _tmp14_;
	SudokuCell* _tmp15_;
#line 347 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 349 "../src/sudoku-view.vala"
	_tmp2_ = sudoku_view_get_highlighter (self);
#line 349 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 349 "../src/sudoku-view.vala"
	if (!_tmp3_) {
#line 349 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 2155 "sudoku-view.c"
	} else {
#line 349 "../src/sudoku-view.vala"
		_tmp1_ = val == 0;
#line 2159 "sudoku-view.c"
	}
#line 349 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 349 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 2165 "sudoku-view.c"
	} else {
#line 349 "../src/sudoku-view.vala"
		_tmp0_ = !self->highlight_numbers;
#line 2169 "sudoku-view.c"
	}
#line 349 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 350 "../src/sudoku-view.vala"
		return;
#line 2175 "sudoku-view.c"
	}
#line 352 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->cells;
#line 352 "../src/sudoku-view.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 352 "../src/sudoku-view.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 352 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->_selected_row;
#line 352 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->_selected_col;
#line 352 "../src/sudoku-view.vala"
	_tmp7_ = _tmp4_[(_tmp5_ * _tmp4__length2) + _tmp6_];
#line 352 "../src/sudoku-view.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 352 "../src/sudoku-view.vala"
	cell = _tmp8_;
#line 354 "../src/sudoku-view.vala"
	_tmp9_ = cell;
#line 354 "../src/sudoku-view.vala"
	_tmp10_ = sudoku_cell_get_value (_tmp9_);
#line 354 "../src/sudoku-view.vala"
	_tmp11_ = _tmp10_;
#line 354 "../src/sudoku-view.vala"
	if (val != _tmp11_) {
#line 355 "../src/sudoku-view.vala"
		_g_object_unref0 (cell);
#line 355 "../src/sudoku-view.vala"
		return;
#line 2205 "sudoku-view.c"
	}
#line 357 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->cells;
#line 357 "../src/sudoku-view.vala"
	_tmp12__length1 = self->priv->cells_length1;
#line 357 "../src/sudoku-view.vala"
	_tmp12__length2 = self->priv->cells_length2;
#line 357 "../src/sudoku-view.vala"
	_tmp13_ = _tmp12_[(row * _tmp12__length2) + col];
#line 357 "../src/sudoku-view.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 357 "../src/sudoku-view.vala"
	changed_cell = _tmp14_;
#line 358 "../src/sudoku-view.vala"
	_tmp15_ = changed_cell;
#line 358 "../src/sudoku-view.vala"
	sudoku_cell_set_highlight_number (_tmp15_, enabled);
#line 347 "../src/sudoku-view.vala"
	_g_object_unref0 (changed_cell);
#line 347 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 2227 "sudoku-view.c"
}

void
sudoku_view_update_zoom (SudokuView* self,
                         ZoomLevel level)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 361 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 363 "../src/sudoku-view.vala"
	self->zoom_level = level;
#line 364 "../src/sudoku-view.vala"
	switch (level) {
#line 364 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_SMALL:
#line 2245 "sudoku-view.c"
		{
#line 367 "../src/sudoku-view.vala"
			self->value_zoom_multiplier = 0.4;
#line 368 "../src/sudoku-view.vala"
			break;
#line 2251 "sudoku-view.c"
		}
#line 364 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 2255 "sudoku-view.c"
		{
#line 370 "../src/sudoku-view.vala"
			self->value_zoom_multiplier = 0.5;
#line 371 "../src/sudoku-view.vala"
			break;
#line 2261 "sudoku-view.c"
		}
#line 364 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_LARGE:
#line 2265 "sudoku-view.c"
		{
#line 373 "../src/sudoku-view.vala"
			self->value_zoom_multiplier = 0.6;
#line 374 "../src/sudoku-view.vala"
			break;
#line 2271 "sudoku-view.c"
		}
		default:
#line 364 "../src/sudoku-view.vala"
		break;
#line 2276 "sudoku-view.c"
	}
#line 376 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 376 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 376 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 2284 "sudoku-view.c"
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
#line 376 "../src/sudoku-view.vala"
		cell_collection = _tmp0_;
#line 376 "../src/sudoku-view.vala"
		cell_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 376 "../src/sudoku-view.vala"
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
#line 2296 "sudoku-view.c"
			SudokuCell* _tmp1_;
			SudokuCell* cell = NULL;
#line 376 "../src/sudoku-view.vala"
			_tmp1_ = _g_object_ref0 (cell_collection[cell_it]);
#line 376 "../src/sudoku-view.vala"
			cell = _tmp1_;
#line 2303 "sudoku-view.c"
			{
				SudokuCell* _tmp2_;
#line 377 "../src/sudoku-view.vala"
				_tmp2_ = cell;
#line 377 "../src/sudoku-view.vala"
				gtk_widget_queue_allocate ((GtkWidget*) _tmp2_);
#line 376 "../src/sudoku-view.vala"
				_g_object_unref0 (cell);
#line 2312 "sudoku-view.c"
			}
		}
	}
}

static void
sudoku_view_update_warnings (SudokuView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 380 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 382 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 382 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 383 "../src/sudoku-view.vala"
		return;
#line 2333 "sudoku-view.c"
	}
	{
		gint col = 0;
#line 385 "../src/sudoku-view.vala"
		col = 0;
#line 2339 "sudoku-view.c"
		{
			gboolean _tmp2_ = FALSE;
#line 385 "../src/sudoku-view.vala"
			_tmp2_ = TRUE;
#line 385 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2346 "sudoku-view.c"
				SudokuGame* _tmp4_;
				SudokuBoard* _tmp5_;
				SudokuBoard* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 385 "../src/sudoku-view.vala"
				if (!_tmp2_) {
#line 2354 "sudoku-view.c"
					gint _tmp3_;
#line 385 "../src/sudoku-view.vala"
					_tmp3_ = col;
#line 385 "../src/sudoku-view.vala"
					col = _tmp3_ + 1;
#line 2360 "sudoku-view.c"
				}
#line 385 "../src/sudoku-view.vala"
				_tmp2_ = FALSE;
#line 385 "../src/sudoku-view.vala"
				_tmp4_ = self->priv->game;
#line 385 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 385 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 385 "../src/sudoku-view.vala"
				_tmp7_ = sudoku_board_get_cols (_tmp6_);
#line 385 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_;
#line 385 "../src/sudoku-view.vala"
				if (!(col < _tmp8_)) {
#line 385 "../src/sudoku-view.vala"
					break;
#line 2378 "sudoku-view.c"
				}
				{
					gint row = 0;
#line 386 "../src/sudoku-view.vala"
					row = 0;
#line 2384 "sudoku-view.c"
					{
						gboolean _tmp9_ = FALSE;
#line 386 "../src/sudoku-view.vala"
						_tmp9_ = TRUE;
#line 386 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2391 "sudoku-view.c"
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
							SudokuCell** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							SudokuCell* _tmp19_;
#line 386 "../src/sudoku-view.vala"
							if (!_tmp9_) {
#line 2407 "sudoku-view.c"
								gint _tmp10_;
#line 386 "../src/sudoku-view.vala"
								_tmp10_ = row;
#line 386 "../src/sudoku-view.vala"
								row = _tmp10_ + 1;
#line 2413 "sudoku-view.c"
							}
#line 386 "../src/sudoku-view.vala"
							_tmp9_ = FALSE;
#line 386 "../src/sudoku-view.vala"
							_tmp11_ = self->priv->game;
#line 386 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 386 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 386 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_rows (_tmp13_);
#line 386 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 386 "../src/sudoku-view.vala"
							if (!(row < _tmp15_)) {
#line 386 "../src/sudoku-view.vala"
								break;
#line 2431 "sudoku-view.c"
							}
#line 388 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 388 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 388 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 388 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(row * _tmp16__length2) + col];
#line 388 "../src/sudoku-view.vala"
							sudoku_cell_check_value_warnings (_tmp17_);
#line 389 "../src/sudoku-view.vala"
							_tmp18_ = self->priv->cells;
#line 389 "../src/sudoku-view.vala"
							_tmp18__length1 = self->priv->cells_length1;
#line 389 "../src/sudoku-view.vala"
							_tmp18__length2 = self->priv->cells_length2;
#line 389 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
#line 389 "../src/sudoku-view.vala"
							sudoku_cell_check_earmarks_warnings (_tmp19_);
#line 2453 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_all_warnings (SudokuView* self)
{
#line 393 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2467 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 395 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2472 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 395 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 395 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2479 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 395 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2487 "sudoku-view.c"
					gint _tmp1_;
#line 395 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 395 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2493 "sudoku-view.c"
				}
#line 395 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 395 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 395 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 395 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 395 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 395 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 395 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 395 "../src/sudoku-view.vala"
					break;
#line 2511 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 396 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2517 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 396 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 396 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2524 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 396 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2536 "sudoku-view.c"
								gint _tmp8_;
#line 396 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 396 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2542 "sudoku-view.c"
							}
#line 396 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 396 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 396 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 396 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 396 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 396 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 396 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 396 "../src/sudoku-view.vala"
								break;
#line 2560 "sudoku-view.c"
							}
#line 397 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 397 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 397 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 397 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 397 "../src/sudoku-view.vala"
							sudoku_cell_clear_warnings (_tmp15_);
#line 2572 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_mask_view (SudokuView* self)
{
#line 400 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2586 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 402 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2591 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 402 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 402 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2598 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 402 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2606 "sudoku-view.c"
					gint _tmp1_;
#line 402 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 402 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2612 "sudoku-view.c"
				}
#line 402 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 402 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 402 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 402 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 402 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 402 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 402 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 402 "../src/sudoku-view.vala"
					break;
#line 2630 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 403 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2636 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 403 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 403 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2643 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 403 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2655 "sudoku-view.c"
								gint _tmp8_;
#line 403 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 403 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2661 "sudoku-view.c"
							}
#line 403 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 403 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 403 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 403 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 403 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 403 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 403 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 403 "../src/sudoku-view.vala"
								break;
#line 2679 "sudoku-view.c"
							}
#line 404 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 404 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 404 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 404 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 404 "../src/sudoku-view.vala"
							sudoku_cell_set_paused (_tmp15_, TRUE);
#line 2691 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_unmask_view (SudokuView* self)
{
#line 407 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2705 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 409 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2710 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 409 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 409 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2717 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 409 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2725 "sudoku-view.c"
					gint _tmp1_;
#line 409 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 409 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2731 "sudoku-view.c"
				}
#line 409 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 409 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 409 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 409 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 409 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 409 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 409 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 409 "../src/sudoku-view.vala"
					break;
#line 2749 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 410 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2755 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 410 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 410 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2762 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 410 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2774 "sudoku-view.c"
								gint _tmp8_;
#line 410 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 410 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2780 "sudoku-view.c"
							}
#line 410 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 410 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 410 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 410 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 410 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 410 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 410 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 410 "../src/sudoku-view.vala"
								break;
#line 2798 "sudoku-view.c"
							}
#line 411 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 411 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 411 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 411 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 411 "../src/sudoku-view.vala"
							sudoku_cell_set_paused (_tmp15_, FALSE);
#line 2810 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_dismiss_popovers (SudokuView* self)
{
#line 491 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2824 "sudoku-view.c"
	{
		gint i = 0;
#line 493 "../src/sudoku-view.vala"
		i = 0;
#line 2829 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 493 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 493 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2836 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 493 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2844 "sudoku-view.c"
					gint _tmp1_;
#line 493 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 493 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2850 "sudoku-view.c"
				}
#line 493 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 493 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 493 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 493 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 493 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_rows (_tmp4_);
#line 493 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 493 "../src/sudoku-view.vala"
				if (!(i < _tmp6_)) {
#line 493 "../src/sudoku-view.vala"
					break;
#line 2868 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 494 "../src/sudoku-view.vala"
					j = 0;
#line 2874 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 494 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 494 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2881 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 494 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2893 "sudoku-view.c"
								gint _tmp8_;
#line 494 "../src/sudoku-view.vala"
								_tmp8_ = j;
#line 494 "../src/sudoku-view.vala"
								j = _tmp8_ + 1;
#line 2899 "sudoku-view.c"
							}
#line 494 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 494 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 494 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 494 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 494 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 494 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 494 "../src/sudoku-view.vala"
							if (!(j < _tmp13_)) {
#line 494 "../src/sudoku-view.vala"
								break;
#line 2917 "sudoku-view.c"
							}
#line 495 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 495 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 495 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 495 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(i * _tmp14__length2) + j];
#line 495 "../src/sudoku-view.vala"
							sudoku_cell_dismiss_popover (_tmp15_);
#line 2929 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_real_dispose (GObject* base)
{
	SudokuView * self;
	SudokuFrame* _tmp0_;
#line 498 "../src/sudoku-view.vala"
	self = (SudokuView*) base;
#line 500 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->frame;
#line 500 "../src/sudoku-view.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 501 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_bin_get_type (), AdwBin));
#line 2951 "sudoku-view.c"
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
#line 43 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/sudoku-view.vala"
	result = self->priv->_selected_row;
#line 43 "../src/sudoku-view.vala"
	return result;
#line 2964 "sudoku-view.c"
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 43 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_row (self);
#line 43 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 43 "../src/sudoku-view.vala"
		self->priv->_selected_row = value;
#line 43 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
#line 2982 "sudoku-view.c"
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
#line 44 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/sudoku-view.vala"
	result = self->priv->_selected_col;
#line 44 "../src/sudoku-view.vala"
	return result;
#line 2996 "sudoku-view.c"
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 44 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_col (self);
#line 44 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 44 "../src/sudoku-view.vala"
		self->priv->_selected_col = value;
#line 44 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
#line 3014 "sudoku-view.c"
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 417 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 417 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 417 "../src/sudoku-view.vala"
	return result;
#line 3028 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 418 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 419 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 421 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 421 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 421 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 422 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 3051 "sudoku-view.c"
	} else {
#line 424 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 3055 "sudoku-view.c"
	}
#line 426 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 426 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 426 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 418 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 3065 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_earmark_warnings (SudokuView* self)
{
	gboolean result;
#line 433 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 433 "../src/sudoku-view.vala"
	result = self->priv->_show_earmark_warnings;
#line 433 "../src/sudoku-view.vala"
	return result;
#line 3078 "sudoku-view.c"
}

void
sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                       gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 434 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/sudoku-view.vala"
	self->priv->_show_earmark_warnings = value;
#line 436 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 436 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 436 "../src/sudoku-view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 434 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY]);
#line 3099 "sudoku-view.c"
}

gboolean
sudoku_view_get_solution_warnings (SudokuView* self)
{
	gboolean result;
#line 443 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 443 "../src/sudoku-view.vala"
	result = self->priv->_solution_warnings;
#line 443 "../src/sudoku-view.vala"
	return result;
#line 3112 "sudoku-view.c"
}

void
sudoku_view_set_solution_warnings (SudokuView* self,
                                   gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 444 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 445 "../src/sudoku-view.vala"
	self->priv->_solution_warnings = value;
#line 446 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 446 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 446 "../src/sudoku-view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 444 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY]);
#line 3133 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 453 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 453 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 453 "../src/sudoku-view.vala"
	return result;
#line 3146 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 454 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 455 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 456 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_view_get_show_possibilities (self);
#line 456 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 456 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 3166 "sudoku-view.c"
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 456 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->game;
#line 456 "../src/sudoku-view.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 456 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_;
#line 456 "../src/sudoku-view.vala"
		_tmp0_ = _tmp5_ != GAME_MODE_CREATE;
#line 3178 "sudoku-view.c"
	} else {
#line 456 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 3182 "sudoku-view.c"
	}
#line 456 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 3186 "sudoku-view.c"
		SudokuGame* _tmp6_;
#line 457 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->game;
#line 457 "../src/sudoku-view.vala"
		sudoku_game_enable_all_earmark_possibilities (_tmp6_);
#line 3192 "sudoku-view.c"
	} else {
		SudokuGame* _tmp7_;
#line 458 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->game;
#line 458 "../src/sudoku-view.vala"
		if (sudoku_game_get_current_stack_action (_tmp7_) == STACK_ACTION_ENABLE_ALL_EARMARK_POSSIBILITIES) {
#line 3199 "sudoku-view.c"
			SudokuGame* _tmp8_;
#line 459 "../src/sudoku-view.vala"
			_tmp8_ = self->priv->game;
#line 459 "../src/sudoku-view.vala"
			sudoku_game_undo (_tmp8_);
#line 3205 "sudoku-view.c"
		}
	}
#line 454 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 3210 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 466 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 466 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 466 "../src/sudoku-view.vala"
	return result;
#line 3223 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 467 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 468 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_selected_row;
#line 468 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_col;
#line 468 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp0_, _tmp1_, FALSE);
#line 469 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 470 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 470 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 470 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 467 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 3252 "sudoku-view.c"
}

gboolean
sudoku_view_get_has_selection (SudokuView* self)
{
	gboolean result;
#line 477 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 477 "../src/sudoku-view.vala"
	result = self->priv->_has_selection;
#line 477 "../src/sudoku-view.vala"
	return result;
#line 3265 "sudoku-view.c"
}

void
sudoku_view_set_has_selection (SudokuView* self,
                               gboolean value)
{
	SudokuCell* cell = NULL;
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 478 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 479 "../src/sudoku-view.vala"
	self->priv->_has_selection = value;
#line 480 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 480 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 480 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 480 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 480 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_col;
#line 480 "../src/sudoku-view.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 480 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 480 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 481 "../src/sudoku-view.vala"
	_tmp5_ = cell;
#line 481 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_view_get_has_selection (self);
#line 481 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 481 "../src/sudoku-view.vala"
	sudoku_cell_set_selected (_tmp5_, _tmp7_);
#line 482 "../src/sudoku-view.vala"
	_tmp8_ = sudoku_view_get_has_selection (self);
#line 482 "../src/sudoku-view.vala"
	_tmp9_ = _tmp8_;
#line 482 "../src/sudoku-view.vala"
	if (_tmp9_) {
#line 3323 "sudoku-view.c"
		SudokuCell* _tmp10_;
#line 483 "../src/sudoku-view.vala"
		_tmp10_ = cell;
#line 483 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 3329 "sudoku-view.c"
	} else {
		SudokuCell* _tmp11_;
#line 485 "../src/sudoku-view.vala"
		_tmp11_ = cell;
#line 485 "../src/sudoku-view.vala"
		sudoku_cell_dismiss_popover (_tmp11_);
#line 3336 "sudoku-view.c"
	}
#line 487 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 487 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 487 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_view_get_has_selection (self);
#line 487 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 487 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp12_, _tmp13_, _tmp15_);
#line 478 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 478 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY]);
#line 3352 "sudoku-view.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../src/sudoku-view.vala"
	g_return_if_fail (n_param_values == 5);
#line 26 "../src/sudoku-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../src/sudoku-view.vala"
		data1 = closure->data;
#line 26 "../src/sudoku-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3377 "sudoku-view.c"
	} else {
#line 26 "../src/sudoku-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../src/sudoku-view.vala"
		data2 = closure->data;
#line 3383 "sudoku-view.c"
	}
#line 26 "../src/sudoku-view.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 26 "../src/sudoku-view.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 3389 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda9_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 161 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 162 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 162 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 164 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 164 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 164 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 164 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3417 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 164 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 164 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 164 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3427 "sudoku-view.c"
	}
#line 164 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 165 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 165 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 165 "../src/sudoku-view.vala"
		return result;
#line 3437 "sudoku-view.c"
	}
#line 167 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 167 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 167 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3445 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 168 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 168 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 168 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 168 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 168 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 168 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 168 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(8 * _tmp9__length2) + _tmp11_];
#line 168 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3469 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 170 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 170 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 170 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 170 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 170 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 170 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 170 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 170 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 170 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ - 1) * _tmp14__length2) + _tmp18_];
#line 170 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3500 "sudoku-view.c"
	}
#line 172 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 172 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 172 "../src/sudoku-view.vala"
	return result;
#line 3508 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda9__gtk_shortcut_func (GtkWidget* widget,
                                            GVariant* args,
                                            gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda9_ (widget);
#line 161 "../src/sudoku-view.vala"
	return result;
#line 3520 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda10_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 174 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 175 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 175 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 177 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 177 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 177 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 177 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3548 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 177 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 177 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 177 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3558 "sudoku-view.c"
	}
#line 177 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 178 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 178 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 178 "../src/sudoku-view.vala"
		return result;
#line 3568 "sudoku-view.c"
	}
#line 180 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 180 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 180 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3576 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 181 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 181 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 181 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 181 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 181 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 181 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 181 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(0 * _tmp9__length2) + _tmp11_];
#line 181 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3600 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 183 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 183 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 183 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 183 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 183 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 183 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 183 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 183 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 183 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ + 1) * _tmp14__length2) + _tmp18_];
#line 183 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3631 "sudoku-view.c"
	}
#line 185 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 185 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 185 "../src/sudoku-view.vala"
	return result;
#line 3639 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda10__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda10_ (widget);
#line 174 "../src/sudoku-view.vala"
	return result;
#line 3651 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda11_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 187 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 188 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 188 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 190 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 190 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 190 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 190 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3679 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 190 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 190 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 190 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3689 "sudoku-view.c"
	}
#line 190 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 191 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 191 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 191 "../src/sudoku-view.vala"
		return result;
#line 3699 "sudoku-view.c"
	}
#line 193 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 193 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 193 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3707 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 194 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 194 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 194 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 194 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 194 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 194 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 194 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 8];
#line 194 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3731 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 196 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 196 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 196 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 196 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 196 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 196 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ - 1)];
#line 196 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3762 "sudoku-view.c"
	}
#line 198 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 198 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 198 "../src/sudoku-view.vala"
	return result;
#line 3770 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda11__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda11_ (widget);
#line 187 "../src/sudoku-view.vala"
	return result;
#line 3782 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda12_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 200 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 201 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 201 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 203 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 203 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 203 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 203 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3810 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 203 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 203 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 203 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3820 "sudoku-view.c"
	}
#line 203 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 204 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 204 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 204 "../src/sudoku-view.vala"
		return result;
#line 3830 "sudoku-view.c"
	}
#line 206 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 206 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 206 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3838 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 207 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 207 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 207 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 207 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 207 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 0];
#line 207 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3862 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 209 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 209 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 209 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 209 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 209 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 209 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 209 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 209 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 209 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ + 1)];
#line 209 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3893 "sudoku-view.c"
	}
#line 211 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 211 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 211 "../src/sudoku-view.vala"
	return result;
#line 3901 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda12__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda12_ (widget);
#line 200 "../src/sudoku-view.vala"
	return result;
#line 3913 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
#line 26 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/sudoku-view.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_view_real_dispose;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-earmark-warnings", "show-earmark-warnings", "show-earmark-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY] = g_param_spec_boolean ("solution-warnings", "solution-warnings", "solution-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HAS_SELECTION_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", TYPE_SUDOKU_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 161 "../src/sudoku-view.vala"
	up_func = __sudoku_view___lambda9__gtk_shortcut_func;
#line 161 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 161 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 174 "../src/sudoku-view.vala"
	down_func = __sudoku_view___lambda10__gtk_shortcut_func;
#line 174 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 174 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 187 "../src/sudoku-view.vala"
	left_func = __sudoku_view___lambda11__gtk_shortcut_func;
#line 187 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 187 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 200 "../src/sudoku-view.vala"
	right_func = __sudoku_view___lambda12__gtk_shortcut_func;
#line 200 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 200 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 214 "../src/sudoku-view.vala"
	_tmp0_ = up_func;
#line 214 "../src/sudoku-view.vala"
	_tmp0__target = up_func_target;
#line 214 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
#line 215 "../src/sudoku-view.vala"
	_tmp1_ = up_func;
#line 215 "../src/sudoku-view.vala"
	_tmp1__target = up_func_target;
#line 215 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
#line 216 "../src/sudoku-view.vala"
	_tmp2_ = up_func;
#line 216 "../src/sudoku-view.vala"
	_tmp2__target = up_func_target;
#line 216 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
#line 217 "../src/sudoku-view.vala"
	_tmp3_ = down_func;
#line 217 "../src/sudoku-view.vala"
	_tmp3__target = down_func_target;
#line 217 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
#line 218 "../src/sudoku-view.vala"
	_tmp4_ = down_func;
#line 218 "../src/sudoku-view.vala"
	_tmp4__target = down_func_target;
#line 218 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
#line 219 "../src/sudoku-view.vala"
	_tmp5_ = down_func;
#line 219 "../src/sudoku-view.vala"
	_tmp5__target = down_func_target;
#line 219 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
#line 220 "../src/sudoku-view.vala"
	_tmp6_ = left_func;
#line 220 "../src/sudoku-view.vala"
	_tmp6__target = left_func_target;
#line 220 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
#line 221 "../src/sudoku-view.vala"
	_tmp7_ = left_func;
#line 221 "../src/sudoku-view.vala"
	_tmp7__target = left_func_target;
#line 221 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
#line 222 "../src/sudoku-view.vala"
	_tmp8_ = left_func;
#line 222 "../src/sudoku-view.vala"
	_tmp8__target = left_func_target;
#line 222 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
#line 223 "../src/sudoku-view.vala"
	_tmp9_ = right_func;
#line 223 "../src/sudoku-view.vala"
	_tmp9__target = right_func_target;
#line 223 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
#line 224 "../src/sudoku-view.vala"
	_tmp10_ = right_func;
#line 224 "../src/sudoku-view.vala"
	_tmp10__target = right_func_target;
#line 224 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
#line 225 "../src/sudoku-view.vala"
	_tmp11_ = right_func;
#line 225 "../src/sudoku-view.vala"
	_tmp11__target = right_func_target;
#line 225 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
#line 160 "../src/sudoku-view.vala"
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
#line 160 "../src/sudoku-view.vala"
	right_func = NULL;
#line 160 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 160 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 160 "../src/sudoku-view.vala"
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
#line 160 "../src/sudoku-view.vala"
	left_func = NULL;
#line 160 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 160 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 160 "../src/sudoku-view.vala"
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
#line 160 "../src/sudoku-view.vala"
	down_func = NULL;
#line 160 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 160 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 160 "../src/sudoku-view.vala"
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
#line 160 "../src/sudoku-view.vala"
	up_func = NULL;
#line 160 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 160 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 4114 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 34 "../src/sudoku-view.vala"
	self->earmark_mode = FALSE;
#line 43 "../src/sudoku-view.vala"
	self->priv->_selected_row = 0;
#line 44 "../src/sudoku-view.vala"
	self->priv->_selected_col = 0;
#line 474 "../src/sudoku-view.vala"
	self->priv->_has_selection = TRUE;
#line 4131 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->settings);
#line 29 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 30 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 31 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->frame);
#line 32 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 4152 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_row (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_col (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_earmark_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_solution_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_has_selection (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4235 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4241 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_row (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_col (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_earmark_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_solution_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_has_selection (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4303 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4309 "sudoku-view.c"
	}
}

gboolean
zoom_level_is_fully_zoomed_out (ZoomLevel self)
{
	gboolean result;
#line 513 "../src/sudoku-view.vala"
	switch (self) {
#line 513 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4321 "sudoku-view.c"
		{
#line 516 "../src/sudoku-view.vala"
			result = TRUE;
#line 516 "../src/sudoku-view.vala"
			return result;
#line 4327 "sudoku-view.c"
		}
		default:
		{
#line 518 "../src/sudoku-view.vala"
			result = FALSE;
#line 518 "../src/sudoku-view.vala"
			return result;
#line 4335 "sudoku-view.c"
		}
	}
}

gboolean
zoom_level_is_fully_zoomed_in (ZoomLevel self)
{
	gboolean result;
#line 524 "../src/sudoku-view.vala"
	switch (self) {
#line 524 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4348 "sudoku-view.c"
		{
#line 527 "../src/sudoku-view.vala"
			result = TRUE;
#line 527 "../src/sudoku-view.vala"
			return result;
#line 4354 "sudoku-view.c"
		}
		default:
		{
#line 529 "../src/sudoku-view.vala"
			result = FALSE;
#line 529 "../src/sudoku-view.vala"
			return result;
#line 4362 "sudoku-view.c"
		}
	}
}

ZoomLevel
zoom_level_zoom_in (ZoomLevel self)
{
	ZoomLevel result;
#line 535 "../src/sudoku-view.vala"
	switch (self) {
#line 535 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4375 "sudoku-view.c"
		{
#line 538 "../src/sudoku-view.vala"
			result = ZOOM_LEVEL_MEDIUM;
#line 538 "../src/sudoku-view.vala"
			return result;
#line 4381 "sudoku-view.c"
		}
#line 535 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 4385 "sudoku-view.c"
		{
#line 540 "../src/sudoku-view.vala"
			result = ZOOM_LEVEL_LARGE;
#line 540 "../src/sudoku-view.vala"
			return result;
#line 4391 "sudoku-view.c"
		}
#line 535 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4395 "sudoku-view.c"
		{
			{
#line 543 "../src/sudoku-view.vala"
				g_warning ("sudoku-view.vala:543: ZOOM already at maximum");
#line 544 "../src/sudoku-view.vala"
				result = ZOOM_LEVEL_LARGE;
#line 544 "../src/sudoku-view.vala"
				return result;
#line 4404 "sudoku-view.c"
			}
		}
		default:
		{
#line 547 "../src/sudoku-view.vala"
			g_assert_not_reached ();
#line 4411 "sudoku-view.c"
		}
	}
}

ZoomLevel
zoom_level_zoom_out (ZoomLevel self)
{
	ZoomLevel result;
#line 553 "../src/sudoku-view.vala"
	switch (self) {
#line 553 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4424 "sudoku-view.c"
		{
#line 556 "../src/sudoku-view.vala"
			result = ZOOM_LEVEL_MEDIUM;
#line 556 "../src/sudoku-view.vala"
			return result;
#line 4430 "sudoku-view.c"
		}
#line 553 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 4434 "sudoku-view.c"
		{
#line 558 "../src/sudoku-view.vala"
			result = ZOOM_LEVEL_SMALL;
#line 558 "../src/sudoku-view.vala"
			return result;
#line 4440 "sudoku-view.c"
		}
#line 553 "../src/sudoku-view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4444 "sudoku-view.c"
		{
			{
#line 561 "../src/sudoku-view.vala"
				g_warning ("sudoku-view.vala:561: ZOOM already at minimum");
#line 562 "../src/sudoku-view.vala"
				result = ZOOM_LEVEL_SMALL;
#line 562 "../src/sudoku-view.vala"
				return result;
#line 4453 "sudoku-view.c"
			}
		}
		default:
		{
#line 565 "../src/sudoku-view.vala"
			g_assert_not_reached ();
#line 4460 "sudoku-view.c"
		}
	}
}

static GType
zoom_level_get_type_once (void)
{
	static const GEnumValue values[] = {{ZOOM_LEVEL_SMALL, "ZOOM_LEVEL_SMALL", "small"}, {ZOOM_LEVEL_MEDIUM, "ZOOM_LEVEL_MEDIUM", "medium"}, {ZOOM_LEVEL_LARGE, "ZOOM_LEVEL_LARGE", "large"}, {0, NULL, NULL}};
	GType zoom_level_type_id;
	zoom_level_type_id = g_enum_register_static ("ZoomLevel", values);
	return zoom_level_type_id;
}

GType
zoom_level_get_type (void)
{
	static volatile gsize zoom_level_type_id__once = 0;
	if (g_once_init_enter (&zoom_level_type_id__once)) {
		GType zoom_level_type_id;
		zoom_level_type_id = zoom_level_get_type_once ();
		g_once_init_leave (&zoom_level_type_id__once, zoom_level_type_id);
	}
	return zoom_level_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

